﻿<?php
/*********************************************************************
*@filename Csvuseapp.php
*@description
*@note
*@histories  rivision	author		date		comment
*            2.0        xht         2009/04/28  modify for LogvillageChinese
*            2.0	    sunhy         2009/05/06  modify for  LV20R1-257
*            2.0        xushanning  2009/06/05 mofify for LogvillageChinese
*            2.0        yzl		  2009/07/14   mofify for LV20R1-228
*            2.0        yaozl	   2009/09/01   modify for LV20R1-280
*            2.0        yaozl	   2009/09/07   modify for LV20R1-280再
********************************************************************/
class AssetsMngHdwsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Host','Asthrd','Hrdcpu','Hrddrv','Hrdmem','Hrdmnt','Hrdnic','Astose','Astact','Grpauth','Configure','Group','Hrdphydsk','Hrdlogdsk','Astsfw','Addition','Hstadt','Hstalthrd','Hstloghead');
	var $layout='assets';
	function beforeFilter()
	{
		parent::beforeFilter();

		$assets_111=__('assets_111',$retrun=true);
		$pc_111=__('pc_111',$retrun=true);
		$hdw=__('hdw',$retrun=true);
		$this->pageTitle =$assets_111."/".$pc_111."/".$hdw;
		//xushanning start 2009/05/26  modify for LogvillageChinese
		//$this->Configure->write('debug',2);
		//xushanning end 2009/05/26  modify for LogvillageChinese
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function detail($id = null,$type = null){	
		$this->set('id',$id);
		$this->layout='ajax';
		$asso = array(
		'Host : hosts' => array('Asthrd.host_id = Host.id '),
		'Astose : astoses' => array('Astose.host_id = Host.id '),
		) ;

		$fields_Host = array(
		'Host.id',
		'Host.host_name',
		'Asthrd.id'
		);

		$fields_Astose = array(
		'Astose.os_name',
		'Astose.servicepack',
		'Astose.product_id',
		'Astose.install_time',
		'Astose.activation',
		'Astose.user_name',
		'Astose.organization',
		'Astose.description',
		);

		$Hosts= $this->Host->find("Host.id = ".$id, 'Host.host_name', null,1,null,-1);
		$host_name = $Hosts['Host']['host_name'];

		$this->set('Hosts',$Hosts);
		!empty($Hosts)?$this->set('Hosts',$Hosts):$this->set('Hosts',"");

		$criteria_hostId = "Asthrd.host_id=".$id."";
		$Asthrd_id = $this->Asthrd->find($criteria_hostId,'Asthrd.id');
		///================= asthrd id----------
		$condition[] ="Asthrd.id  = ".$Asthrd_id['Asthrd']['id'];
		$condition['GROUP BY']="Asthrd.id,Asthrd.machine,Asthrd.maker,Asthrd.serialno";
		$fields_Asthrd = array(
		'Asthrd.id',
		'Asthrd.machine',
		'Asthrd.maker',
		'Asthrd.serialno');
		$Asthrds = $this->Asthrd->find($condition, $fields_Asthrd, 'Asthrd.id',null,null, -1);
		!empty($Asthrds)?$this->set('Asthrds',$Asthrds):$this->set('Asthrds',"");
		///----------------------------------------------------------------------------
		$criteria_Astoses=array("Astose.hardware_id=".$Asthrds['Asthrd']['id']);
		$Astoses = $this->Astose->find($criteria_Astoses, $fields_Astose, 'Astose.id', null, null,null);

		!empty($Astoses)?$this->set('Astoses',$Astoses):$this->set('Astoses',"");

		$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
		$Hrddrvs = $this->Hrddrv->findAll("Hrddrv.hardware_id=".$Asthrds['Asthrd']['id'], $Hrddrvs_fields, null, null, null, null);//2007-11-27 変更zhaoli
		//			$Hrddrvs = $this->Hrddrv->findAll("Hrddrv.hardware_id=".$Asthrds['Asthrd']['id'], 'driver_name,driver', null, null, null, null);
		!empty($Hrddrvs)?$this->set('Hrddrv',$Hrddrvs):$this->set('Hrddrv',"");

		$fields1 = array(
		'Astsfw.id',
		'Astsfw.software_name',
		'Astsfw.maker',
		'Astsfw.version',
		'Astsfw.licence_code',
		);
		// $Host_criteria=array("Host.status!= 0 and Grpauth.org_grp_id=".$groupid,"GROUP BY" => $groupBy,);

		$criteria_Astsfws=array('Astsfw.host_id =' .$id,"GROUP BY"=>"Astsfw.host_id");
		$Astsfw_logTime = $this->Astsfw->find($criteria_Astsfws, 'MAX(Astsfw.log_time) AS Astsfw_logtime', null, null, null, -1);
		//debug($Astsfw_logTime,true);

		//--------------------------

		if(!empty($Astsfw_logTime[0]['Astsfw_logtime'])){
			$criteria_Astsfws1=array("(Astsfw.host_id =".$id.") and Astsfw.log_time = "."'".$Astsfw_logTime[0]['Astsfw_logtime']."'","GROUP BY"=>"Astsfw.id,Astsfw.software_name,Astsfw.maker,Astsfw.version,Astsfw.licence_code");
			$criteria_Astsfws1[]="Astsfw.syscomp != True";
			//xinw start 20080221
			$order1="Astsfw.software_name";
			//xinw end 20080221
			//debug($criteria_Astsfws1,true);
			//xinw start 20080221
			$Astsfws = $this->Astsfw->findByAsso($criteria_Astsfws1,$fields1,$order1, null, null, null);}
			//xinw end 20080221
			//	--------------------------

			//$criteria_Astsfws1=array("Astsfw.host_id =".$id,"GROUP BY"=>"Astsfw.id,Astsfw.software_name,Astsfw.maker,Astsfw.version,Astsfw.licence_code");
			//$Astsfws = $this->Astsfw->findAll($criteria_Astsfws1,$fields1, null, null, null, null);

			if(!empty($Astsfws))
			{
				foreach ($Astsfws as $key=>$as)
				{
					if(
					(
					//xinw start 20080221
					strtolower($as['Astsfw']['maker'])=='microsoft corporation'&&(substr(strtolower($as['Astsfw']['software_name']),0,6)=="office"||substr(strtolower($as['Astsfw']['software_name']),0,16)=="microsoft office")
					//xinw end 20080221
					)
					||substr($as['Astsfw']['maker'],0,5)=="Adobe"
					|| $as['Astsfw']['maker'] != ''
					)

					{
						$Astsfws[$key]['Astsfw']['licence_code']=$Astsfws[$key]['Astsfw']['licence_code'];
					}
					else
					{
						$Astsfws[$key]['Astsfw']['licence_code']="";
					}
				}
			}
			//add by WQ  0910
			!empty($Astsfws)?$this->set('Astsfw',$Astsfws):$this->set('Astsfw',"");

			$asso_Astacts = array(
			'Astose : astoses' => array('Astact.os_id = Astose.id'),
			) ;
			$criteria_ast[]="Astose.hardware_id=".$Asthrds['Asthrd']['id'];

			$criteria_ast['GROUP BY']="Astose.hardware_id,Astact.account_name";

			$Astacts = $this->Astact->findByAsso($criteria_ast,array('Astact.account_name'), null, null, null, $asso_Astacts);

			!empty($Astacts)?$this->set('Astact',$Astacts):$this->set('Astact',"");

			// wangs start 20080219
			// $Hrdcpus = $this->Hrdcpu->findAll("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'],array('cpu_name'), null, null, null, -1);
			// !empty($Hrdcpus)?$this->set('Hrdcpu',$Hrdcpus):$this->set('Hrdcpu',"");
			$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'];
			$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
			$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('count(cpu_name) as cpu_num,cpu_name'), 'Hrdcpu.id', 1, null, -1);
			!empty($Hrdcpus)?$this->set('Hrdcpu',$Hrdcpus):$this->set('Hrdcpu',"");
			// wangs end 20080219

			//wangs start 20080219
			$this->set('Hrdcpunum',count($Hrdcpus));
			//wangs end 20080219
			
			

			$Hrdmems = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('capacity'), null, null, null, -1);

			!empty($Hrdmems)?$this->set('Hrdmem',$Hrdmems):$this->set('Hrdmem',"");

			$Hrdmems1 = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(capacity) as Hrdmem__capacity'), null, null, null, -1);
			!empty($Hrdmems1)?$this->set('Hrdmem1',$Hrdmems1):$this->set('Hrdmem1',"");

			$Hrdphydsks = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('allspace','type'), null, null, null, -1);
			!empty($Hrdphydsks)?$this->set('Hrdphydsk',$Hrdphydsks):$this->set('Hrdphydsk',"");

			$Hrdphydsks1 = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(allspace) as Hrdphydsk__allspace'), null, null, null, -1);
			!empty($Hrdphydsks1)?$this->set('Hrdphydsk1',$Hrdphydsks1):$this->set('Hrdphydsk1',"");
			//0904
			$Hrdlogdsks1 = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" => $Asthrds['Asthrd']['id'], "Hrdlogdsk.drivetype != 4"),array('SUM(freespace) as Hrdlogdsk__freespace'), null, null, null, -1);
			!empty($Hrdlogdsks1)?$this->set('Hrdlogdsks1',$Hrdlogdsks1):$this->set('$Hrdlogdsks1',"");

			$Hrdmnts = $this->Hrdmnt->findAll(array("Hrdmnt.hardware_id" => $Asthrds['Asthrd']['id']),array('monitor_name','adapterram','horizontal','vertical','bits'), null, null,null,-1);
			!empty($Hrdmnts)?$this->set('Hrdmnt',$Hrdmnts):$this->set('Hrdmnt',"");

			$criteria_Hrdnics=array("Hrdnic.hardware_id" => $Asthrds['Asthrd']['id']);
			$Hrdnics = $this->Hrdnic->findAll($criteria_Hrdnics,array('nic_name','enableflg','mac_address','ip_address'), null, null, null,-1);
			$this->set('Hrdnic',$Hrdnics);
			$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);

			!empty($Addition)?$this->set('Addition',$Addition):$this->set('Addition',"");

			$Hstadt_asso = array(
			'Hstadt : hstadts' =>array('Hstadt.host_id =Host.id'),
			);

			$Hstadt_fields=array('Host.id',
			'Hstadt.id',
			'Hstadt.option1',
			'Hstadt.option2',
			'Hstadt.option3',
			'Hstadt.option4',
			'Hstadt.option5',
			'Hstadt.option6',
			'Hstadt.option7',
			'Hstadt.option8',
			'Hstadt.option9',
			'Hstadt.option10');

			$criteria_Hstadt=array("Hstadt.host_id=".$id);

			$result_Hstadt = $this->Host->findByAsso($criteria_Hstadt,$Hstadt_fields , null, null, null, $Hstadt_asso);
			!empty($result_Hstadt)?$this->set('result_Hstadt',$result_Hstadt):$this->set('result_Hstadt',"");

			//--csv--  array
			//
			$csv_result=array();
			!empty($Hosts['Host']['host_name'])?$csv_result['Host']['host_name']=$Hosts['Host']['host_name']:$csv_result['Host']['host_name'] =null;
			!empty($Asthrds['Asthrd']['machine'])?$csv_result['Asthrd']['machine']=$Asthrds['Asthrd']['machine']:$csv_result['Asthrd']['machine'] =null;
			!empty($Asthrds['Asthrd']['maker'])?$csv_result['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result['Asthrd']['maker'] =null;
			!empty($Asthrds['Asthrd']['serialno'])?$csv_result['Asthrd']['serialno']= $Asthrds['Asthrd']['serialno']:$csv_result['Asthrd']['serialno'] =null;


			$cpu_total = null;
			$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id']),'count(*) as count',null,null,null ,0);
			if(isset($Hrdcpus_num1)&&$Hrdcpus_num1[0][0]['count']!=0){
				$cpu_total = $Hrdcpus_num1[0][0]['count'];
				$this->set('Hrdcputotal', $cpu_total);
			}
			else{
				$this->set('Hrdcputotal', "");
			}
			for($i=0;$i<count($Hrdcpus);$i++){

				$f='cpu_name'.$i;
				//xinw start 20080221
				//!empty($Hrdcpus[$i]['cpu_name'])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i]['cpu_name']:$csv_result['Hrdcpu'][$f] =null;
			//	!empty($Hrdcpus[$i])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name']:$csv_result['Hrdcpu'][$f] =null;
				//xinw end 20080221
				!empty($Hrdcpus[$i])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name']." ".__('CPU_no_start',true).$cpu_total.__('CPU_no_end',true):$csv_result['Hrdcpu'][$f] =null;
			}



			!empty($Hrdmems1[0]['Hrdmem']['capacity'])?$csv_result['Hrdmem']['capacity']=round($Hrdmems1[0]['Hrdmem']['capacity']/1024,1).'MB':$csv_result['Hrdmem']['capacity']=null;

			!empty($Asthrds['Asthrd']['maker'])?$csv_result['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result['Asthrd']['maker'] =null;

			for($i=0;$i<count($Hrdmems);$i++){
				$f='capacity'.$i;
				$capacity_1 = round($Hrdmems[$i]['Hrdmem']['capacity']/1024,1).'MB';
				!empty($Hrdmems[$i]['Hrdmem']['capacity'])?$csv_result['Hrdmem'][$f]=$capacity_1: $csv_result['Hrdmem'][$f]=null;
			}
			//round($Hrdphydsks[0]['Hrdphydsk']['allspace']/1024/1024,1)
			// yzl start 2009/07/14 modify for LV20R1-228
			//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024,1).'GB/':$allspace_0 =null;
			//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024,1).'GB':$freespace_0 =null;
			!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB/':$allspace_0 =null;
			!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024/1024,1).'GB':$freespace_0 =null;
			// yzl end 2009/07/14 modify for LV20R1-228
			$csv_result['Hrdphydsk']['allspace_freespace']=$allspace_0.$freespace_0;


			for($i=0;$i<count($Hrdphydsks);$i++){
				$f='allspace'.$i;
				// yzl start 2009/07/14 modify for LV20R1-228
				//!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024,1).'GB':$csv_result['Hrdphydsk'][$f]=null;
				!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB':$csv_result['Hrdphydsk'][$f]=null;
				// yzl end 2009/07/14 modify for LV20R1-228
			}


			if(count($Hrddrvs)==1){
				//!empty($Hrddrvs[0]['Hrddrv']['driver_name'])? $csv_result['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name']: $csv_result['Hrddrv']['driver_name']=null;
				if(!empty($Hrddrvs[0]['Hrddrv']['driver_name']))
					$csv_result['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name'].'('.$Hrddrvs[0]['Hrddrv']['driver'].')';
				else
					$csv_result['Hrddrv']['driver_name']=null;
			}
			else{
				for($i=0;$i<count($Hrddrvs);$i++){
					$f='driver_name'.$i;
					//!empty($Hrddrvs[$i]['Hrddrv']['driver_name'])? $csv_result['Hrddrv'][$f] =$Hrddrvs[$i]['Hrddrv']['driver_name']:$csv_result['Hrddrv'][$f]=null;
						
					if(!empty($Hrddrvs['Hrddrv']['driver_name']))
						$csv_result['Hrddrv'][$f]= $Hrddrvs[$i]['Hrddrv']['driver_name'].'('.$Hrddrvs[$i]['Hrddrv']['driver'].')';
					else
						$csv_result['Hrddrv'][$f]=null;
				}
			}


			for($i=0;$i<count($Hrdmnts);$i++){
				$f='monitor_name'.$i;
				$g='adapterram'.$i;
				$h='horizontal.vertical.bits'.$i;
				$adapterram_0 =round($Hrdmnts[$i] ['Hrdmnt']['adapterram']/1024,1);

				!empty($Hrdmnts[$i]['Hrdmnt']['monitor_name'])? $csv_result['Hrdmnt'][$f]=$Hrdmnts[$i]['Hrdmnt']['monitor_name']:$csv_result['Hrdmnt'][$f]=null;
				!empty($Hrdmnts[$i]['Hrdmnt']['adapterram'])? $csv_result['Hrdmnt'][$g]=round($Hrdmnts[$i]['Hrdmnt']['adapterram']/1024,1).'MB':$csv_result['Hrdmnt'][$g]=null;
				!empty($Hrdmnts[$i]['Hrdmnt']['horizontal'])? $csv_result['Hrdmnt'][$h]=$Hrdmnts[$i]['Hrdmnt']['horizontal'].'*'.$Hrdmnts[$i]['Hrdmnt']['vertical'].'('.$Hrdmnts[$i]['Hrdmnt']['bits'].'bit'.')':$csv_result['Hrdmnt'][$h]=null;
			}


			for($i=0;$i<count($Hrdnics);$i++){
				$f='nic_name'.$i;
				$g='mac_address'.$i;
				$h='ip_address'.$i;
				if($Hrdnics[$i]['Hrdnic']['enableflg']==0){
					$enable=__('use',true);
				}
				else{ $enable=__('nouse',true);}
				!empty($Hrdnics[$i]['Hrdnic']['nic_name']) ?$csv_result['Hrdnic'][$f] = $Hrdnics[$i]['Hrdnic']['nic_name'].'('.$enable.')':$csv_result['Hrdnic'][$f]=null;
				!empty($Hrdnics[$i]['Hrdnic']['mac_address']) ?$csv_result['Hrdnic'][$g] = $Hrdnics[$i]['Hrdnic']['mac_address']:$csv_result['Hrdnic'][$g]=null;
				!empty($Hrdnics[$i]['Hrdnic']['ip_address']) ? $csv_result['Hrdnic'][$h] = $Hrdnics[$i]['Hrdnic']['ip_address']:$csv_result['Hrdnic'][$h]=null;
			}
			!empty($Astoses['Astose']['os_name'])?$csv_result['Astose']['os_name']= $Astoses['Astose']['os_name']:$csv_result['Astose']['os_name'] =null;
			!empty($Astoses['Astose']['product_id'])?$csv_result['Astose']['product_id']= $Astoses['Astose']['product_id']:$csv_result['Astose']['product_id'] =null;
			!empty($Astoses['Astose']['install_time'])?$csv_result['Astose']['install_time']= $Astoses['Astose']['install_time']:$csv_result['Astose']['install_time'] =null;
			isset($Astoses['Astose']['activation'])?$Astose_activation= $Astoses['Astose']['activation'] :$Astose_activation =null;

			//xinw start 20080217
			//xushanning start 2009/06/05 mofify for LogvillageChinese
			// yaozl start 2009/09/01 modify for LV20R1-280
			//if ($Astose_activation == '0') {
			//if ($Astose_activation == '1') {
			if ($Astose_activation == '0') {
			// yaozl end 2009/09/01 modify for LV20R1-280				
			//xushanning end 2009/06/05 mofify for LogvillageChinese
				$Astose_activation='○';
			}
			//xushanning start 2009/06/05 mofify for LogvillageChinese
			// yaozl start 2009/09/01 modify for LV20R1-280
			//if($Astose_activation=='1'){
			//if($Astose_activation=='0'){
			if($Astose_activation=='1'){
			// yaozl end 2009/09/01 modify for LV20R1-280				
			//xushanning end 2009/06/05 mofify for LogvillageChinese
				$Astose_activation='×';
			}
			// yaozl start 2009/09/01 modify for LV20R1-280
			if (strpos($Astoses['Astose']['os_name'],"2000")) {
				$Astose_activation = "-";
			}
			// yaozl end 2009/09/01 modify for LV20R1-280
			//xinw end 20080217
			$this->set('Astose_activation',$Astose_activation);

			isset($Astoses['Astose']['activation'])?$csv_result['Astose']['activation']= $Astose_activation :$csv_result['Astose']['activation'] =null;
			//			 $this->set('Astose_activation',$Astose_activation);

			!empty($Astoses)?$csv_result['Astose']['user_name']= $Astoses['Astose']['user_name']:$csv_result['Astose']['user_name'] =null;
			!empty($Astoses)?$csv_result['Astose']['organization']= $Astoses['Astose']['organization']:$csv_result['Astose']['organization'] =null;
			!empty($Astoses)?$csv_result['Astose']['description']= $Astoses['Astose']['description']:$csv_result['Astose']['description'] =null;

			$result_Astacts="";

			for($i=0;$i<count($Astacts);$i++){
				$f=$Astacts[$i]['Astact']['account_name'].' , ';
				!empty($Astacts[$i]['Astact']['account_name'])?$result_Astacts=$result_Astacts.$f:$result_Astacts=null;
			}

			$result_Astacts = substr($result_Astacts, 0, strlen($result_Astacts)-2);

			!empty($result_Astacts)?$csv_result['Astact']['account_name'] = $result_Astacts:$csv_result['Astact']['account_name']=null;

			if(!empty($Addition)&&!empty($result_Hstadt)){

				foreach ($Addition as $v){
					$f =$v['Addition']['addition_name'];
					// zhangs start 20080218
					// !empty( $csv_result['Hstadt'][$f])? $csv_result['Hstadt'][$f] =  $csv_result['Hstadt'][$f]: $csv_result['Hstadt'][$f] =NULL;}
					!empty($f)? $csv_result['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result['Hstadt'][$f] =NULL;}
					// zhangs end 20080218
			}
			//
			//			            echo"<pre>";
			//			            var_dump($csv_result);
			//--end csv array--
			//         debug($csv_result,true);exit;
			if($type =='csv1')
			{
				$this->csvdown1($Asthrds['Asthrd']['id'],$Astsfws,$csv_result);exit;
			}

	}

	function index2($sf1=null,$sf4=null)
	{
		//echo '@@@@@@@@@@@@@@@@@@@@@@@@@@'.$sf1.'#####'.$sf4;
		$this->index($sf1, null, null,$sf4);
		$this->render("index");
	}
	function index($sf1=null,$sf2=null,$sf3=null,$sf4=null,$sf5=null,$hoststatus=null){
		if(!empty($sf1)||!empty($sf2)||!empty($sf3)||!empty($sf4)||!empty($sf5)){

			$this->set('sf1',$sf1);//グループ
			$this->set('sf2',$sf2);//ソフト名
			$this->set('sf3',$sf3);
			$this->set('sf4',$sf4);//メーカー
			$this->set('sf5',$sf5);//ライセンスコード
		}
		//    	 echo "==============1==================";
		$group = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('group',$group);
		if(isset($sf1))
		{
			$this->set('sf1',$sf1);

		}
		//SW台帳から飛んできたとき
		if(!is_null($hoststatus))
			$this->data['Host']['status'] = $hoststatus;
	}

	function search($type = null){
		  //debug($_POST, true);
		  $this->layout="ajax";	
//var_dump($type);
//var_dump(is_null($this->data['Asthrd']['search_by_date']));

		 $date_criteria = "";
		 $hdwslist = array();
		if($type != 'back' && !is_null($this->data['Asthrd']['search_by_date']) ){

			if($this->data['Asthrd']['search_by_date'] != 0 ){
				$error = array();
				if(false == checkdate($this->data['dt_check']['start_month'], $this->data['dt_check']['start_day'], $this->data['dt_check']['start_year'])){
					//$this->layout='ajax';
					$error[] = __("E-01100", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$start_time = $this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
				if(false == checkdate($this->data['dt_check']['end_month'], $this->data['dt_check']['end_day'], $this->data['dt_check']['end_year'])){
					//$this->layout='ajax';
					$error[] = __("E-01100", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$end_time = $this->data['dt_check']['end_year']."-".$this->data['dt_check']['end_month']."-".$this->data['dt_check']['end_day'];
				if($start_time > $end_time){
					//$this->layout='ajax';
					$error[] = __("error_date", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$datefield = "";
				if($this->data['Asthrd']['search_by_date'] == 1 )
					$datefield = "Asthrd.log_time";
				else if($this->data['Asthrd']['search_by_date'] == 2 )
					$datefield = "Host.regist_time";
				else if($this->data['Asthrd']['search_by_date'] == 3 )
					$datefield = "Host.update_time";
				 $date_criteria = $datefield ." BETWEEN '".$start_time."' and '".$end_time."' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND" ;
			//echo $date_criteria;
				$this->data['dt_check']['criteria'] = $date_criteria;
				
				$hdwslist['date_criteria']=$date_criteria;
			}
			
			$hdwslist['groupname']=$this->data['Group']['groupname'];
				$hdwslist['input_keyword']=$this->data['Asthrd']['input_keyword'];
				
				$hdwslist['sf1']=$this->data['Astsfw']['sf1'];
				$hdwslist['sf2']=$this->data['Astsfw']['sf2'];
				$hdwslist['sf3']=$this->data['Astsfw']['sf3'];
				$hdwslist['sf4']=$this->data['Astsfw']['sf4'];
				$hdwslist['sf5']=$this->data['Astsfw']['sf5'];
				
				
				$this->Session->write('hdwslist', $hdwslist);
				//echo "write";
			//debug($hdwslist);
		}elseif($type == 'back')
		{//詳細から戻ってきた場合,項目値をクリックした場合
			$hdwslist = $this->Session->read('hdwslist');
			$this->data['dt_check']['criteria'] =$hdwslist['date_criteria'];
			$this->data['Group']['groupname'] = $hdwslist['groupname'];
			$this->data['Asthrd']['input_keyword']=	$hdwslist['input_keyword'];
			
				$this->data['Astsfw']['sf1'] = $hdwslist['sf1'];
				$this->data['Astsfw']['sf2'] = $hdwslist['sf2'];
				$this->data['Astsfw']['sf3'] = $hdwslist['sf3'];
				$this->data['Astsfw']['sf4'] = $hdwslist['sf4'];
				$this->data['Astsfw']['sf5'] = $hdwslist['sf5'];
				
				//echo "read";
		//debug($hdwslist);	
		}
		  
		$csv_result1=array();
		if(!empty($this->data['Group']['groupname'])){
			$group_id = $this->data['Group']['groupname'];
			$groupname_csv=$this->Group->find(array("Group.id=$group_id"),'Group.group_name',null,null,null,-1);  
		}
			
			!empty($groupname_csv['Group']['group_name'])?$csv_result1['Group']['groupname']=$groupname_csv['Group']['group_name']:$csv_result1['Group']['groupname']=null;
			if(!empty($this->data['Asthrd']['input_keyword'])){
				$input_keyword=$this->data['Asthrd']['input_keyword'] ;
				!empty($input_keyword)?$csv_result1['Asthrd']['input_keyword']=$input_keyword:$csv_result1['Asthrd']['input_keyword']=null;
			}

				$this->addModel("Temp");
				$this->Temp->useTable = "temppsoptusers";
				$this->lists();
				
				//$link_keyword= $this->Lv->url_param_decode2($this->data['host']['link_keyword']);
				$link_keyword= urldecode($this->data['host']['link_keyword']);
				//$link_title_mun=$this->Lv->url_param_decode2($this->data['host']['link_title_mun']) ;
				$link_title_mun= urldecode($this->data['host']['link_title_mun']) ;
				//echo $link_keyword." ".$link_title_mun;return;
				$input_keyword=$this->data['Asthrd']['input_keyword'] ;
				$groupid = $this->data['Group']['groupname'] ;

				$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);
				$this->set('Addition',$Addition);

				$Hstalthrd = $this->Hstalthrd->find();

				$this->set('Hstalthrd',$Hstalthrd['Hstalthrd']['low']);
				//--laug
				$sear=__('sear',true);
				$mmachine=__('machine',true);
				$mmaker=__('maker',true);
				$mCPU=__('CPU',true);
				$mos=__('OS',true);
				$mSP=__('SP',true);
				//laug
				//xinw start 20080217
				if($link_title_mun==1){
					$this->set('t',$mmachine.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==2){
					$this->set('t',$mmaker.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==3){
					$this->set('t',$mCPU.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==4){
					$this->set('t',$mos.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==5){
					$this->set('t',$mSP.' 「'.$link_keyword.'」 '.$sear);
				}
				else if(!empty($link_title_mun)){
					$this->set('t', htmlspecialchars($link_title_mun)." 「".htmlspecialchars($link_keyword)."」 ".$sear);
				}
				//xinw end 20080217

				if($type==1){
					$this->data['Astsfw']['sf1']='';
					$this->data['Astsfw']['sf2']='';
					$this->data['Astsfw']['sf3']='';
					$this->data['Astsfw']['sf4']='';
					$this->data['Astsfw']['sf5']='';
					//    	$this->data['Astsfw']['sf1']='';
					//    	unset($this->data['Astsfw']['sf2']);
					//    	unset($this->data['Astsfw']['sf3']);
					//    	unset($this->data['Astsfw']['sf4']);
					//    	unset($this->data['Astsfw']['sf5']);
				}		
				
				if($type!='1'&&empty($link_keyword)&&empty($input_keyword))
				{
					if(isset($this->data['Astsfw']['sf1'])){
						$sf_group=$this->data['Astsfw']['sf1'] ;
					}

					if(isset($this->data['Astsfw']['sf2'])){
						$sf_soft=$this->Lv->url_param_decode2($this->data['Astsfw']['sf2']);
					}//	2007/11/28 zhaoli 変更

					if(isset($this->data['Astsfw']['sf3'])){
						$sf_version=$this->Lv->url_param_decode2($this->data['Astsfw']['sf3']);
					}

					if(isset($this->data['Astsfw']['sf4'])){
						$sf_maker=$this->Lv->url_param_decode2($this->data['Astsfw']['sf4']);
					}//	2007/11/28 zhaoli 変更

					if(isset($this->data['Astsfw']['sf5'])) {
						$sf_license=$this->data['Astsfw']['sf5'];
					}

										//							  debug($this->data,true);
				}
				$condition_tem=array("1=1");
				//-------------sfws------------
				if((!empty($sf_group)||!empty($sf_soft)||!empty($sf_version)||!empty($sf_maker)||!empty($sf_license))
					&&(empty($type) || $type=='csv' || $type = 'back')){//(empty($type) || $type=='csv')

					//				echo $type;
					//zhangs start 20080703
					$asso = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
					'C : (select host_id, max(log_time) as log_time from astsfws group by host_id)' => array('C.host_id = Astsfw.host_id and C.log_time = Astsfw.log_time')

					);
					//zhangs end 20080703

					$hcount=array("1=1");
					if(!empty($sf_group)){
						$hcount[]="Grpauth.org_grp_id =".$sf_group."";
						$fg=1;$this->set('fg',$fg);
					}
					if(!empty($sf_soft)){

						$hcount[]="Astsfw.software_name ='".$this->Lv->spec_char_dbm($sf_soft)."'";//	2007/11/28 zhaoli 変更

					}

					if($sf_version =="empty"){
						$hcount[]="Astsfw.version = ''";
					}elseif($sf_version!="null"&&$sf_version!=null){
						$hcount[]="Astsfw.version = '".$this->Lv->spec_char_dbm($sf_version)."'";
					}
					elseif($sf_version =="null"){
						//zhangs start 20080530
//						if(!empty($sf_license)){
							$hcount[] = '1=1';
//						}else{
//							$hcount[]="(Astsfw.version = '' or Astsfw.version is NULL)";
//						}
						//zhangs end 20080530
					}

					if($sf_maker!="null"&&$sf_maker!=null)  {
						//		              $hcount[]="Astsfw.mmaker = '".$sf_maker."'";
						$hcount[]="Astsfw.maker = '".$this->Lv->spec_char_dbm($sf_maker)."'";	//	2007/11/28 zhaoli 変更
					}
					elseif($sf_maker=="null"){
						if(!empty($sf_license)){
							$hcount[] = '1=1';
						}else{
							$hcount[]="(Astsfw.maker = '' or Astsfw.maker is NULL)";
						}
					}

					//----------------------------// 2007/11/21 zhaoli 変更
					$check_office = strrpos($sf_soft, "Office");
					if($check_office === false){


						if(!empty($sf_license)&& $sf_license!="null"){
							//xinw start 20080221
							$hcount[] = "Astsfw.licence_code like '%".$this->Lv->spec_char_like($sf_license)."%'";// 2007/09/25 zhaoli 変更
							//xinw end 20080221
						}

						if($sf_license=="null"){

							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";// 2007/09/25 zhaoli 変更

						}
						//zhangs start 20080723
						if(empty($sf_license)){

							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";
							
						}
						//zhangs end 20080723
					}

					else{

						if(!empty($sf_license)&& $sf_license!="null"){

							//xinw start 20080221
							$hcount[] = "lower(Astsfw.software_name) like '%office%' and LEFT(Astsfw.licence_code,17)  = '".$sf_license."'";
							//xinw end 20080221
						}
						if( $sf_license=="null"){
							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";

						}
						
						//zhangs start 20080723
						if(empty($sf_license)){

							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";

						}
						//zhangs end 20080723
					}
					//---------------------------- 2007/11/21 zhaoli 変更

					//		           if(!empty($sf_license)&& $sf_license!="null"){
					//		           if($sf_license!="null"&&$sf_license!=null){
					//		              $hcount[] = "Astsfw.licence_code = '".$sf_license."'";// 2007/09/25 zhaoli 変更
					//
					//		            	}
					//		           if(empty($sf_license)|| $sf_license=="null"){
					//
					//		              $hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";// 2007/09/25 zhaoli 変更
					//
					//		            	}

					$assoSS = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
					);

					$Astsfw = $this->Astsfw->findByAsso($hcount, array('distinct(Astsfw.host_id) as Astsfw__host_ids'), null, null, null, $asso);



					if(!empty($Astsfw)){
						$Temp_host_id = "";
						foreach ($Astsfw as $v){
							$f =$v['Astsfw']['host_ids'];
							$Temp_host_id =$Temp_host_id.$f.',';
						}
						$Temp_host_id = substr($Temp_host_id, 0, strlen($Temp_host_id)-1);

						if(count($Astsfw) == 1){
							$condition_tem =array( "Temp.host_id =".$Temp_host_id);
						}
						else{ $condition_tem =array( "Temp.host_id in (".$Temp_host_id.")");}

					}
					else{
						$asso_tem = array(

						);

						$tem_crit = "Temp.host_name as Temp__host_name,
							Temp.host_id as Temp__host_id,
							Temp.hardware_id as Temp__hardware_id,
							Temp.machine as Temp__machine,
							Temp.maker as Temp__maker,
							Temp.serialno as Temp__serialno,
							Temp.cpu_name as Temp__cpu_name,
							Temp.cpu_number as Temp__cpu_number,
							Temp.hrdmem_capacity as Temp__hrdmem_capacity,
							Temp.hrdphydsk_allspace as Temp__hrdphydsk_allspace,
							Temp.hrdphydsk_freespace as Temp__hrdphydsk_freespace,
							Temp.hrdphydsk_late as Temp__hrdphydsk_late,
							Temp.os_name as Temp__os_name,
							Temp.servicepack as Temp__servicepack,
							Temp.product_id as Temp__product_id,
							Temp.activation as Temp__activation,
							Temp.description as Temp__description";		

						foreach ($Addition as $v){

							$f =$v['Addition']['addition_name'];
							$a =','.'Temp.'.$f.' as Temp__'.$f;
							$tem_crit = $tem_crit.$a;
						}
						$tem_criteria =	array($tem_crit);
						//		         $condition_tem1 = array("Grpauth.org_grp_id = ". $this->_getUserGroup());
						$condition_tem1 = array("1=1");
						$data1= $this->Temp->findByAsso($condition_tem1, $tem_criteria,'Temp.host_name',null,null,$asso_tem);
						$data_sum = count($data1);
						$this->set( 'data',"");
						$this->set( 'data_sum',$data_sum);
						$this->set( 'data_search',"");

						$this->render('search');
					}
				}

				if(!empty($input_keyword)){

					$keyword = $this->Lv->spec_char_dbm($input_keyword);
					$keyword_like = $this->Lv->spec_char_like($input_keyword);

					$str_host = array();

					//wangs start 20080202
					//	        $str_host[] = "Temp.host_name = '".$keyword."'" ;
					//            $str_host[] = "Temp.host_name like '%".$keyword."%'";
					//
					//            $str_host[] = "Temp.machine = '".$keyword."'" ;
					//	        $str_host[] = "Temp.machine like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.maker = '".$keyword."'";
					//	        $str_host[] = "Temp.maker like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.serialno = '".$keyword."'";
					//	        $str_host[] = "Temp.serialno like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.product_id = '".$keyword."'";
					//	        $str_host[] = "Temp.product_id like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.os_name = '".$keyword."'";
					//	        $str_host[] = "Temp.os_name like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.servicepack = '".$keyword."'";
					//	        $str_host[] = "Temp.servicepack like '%".$keyword."%'";
					//
					//	        $str_host[] = "Temp.cpu_name = '".$keyword."'";
					//	        $str_host[] = "Temp.cpu_name like '%".$keyword."%'";

					$str_host[] = "lower(Temp.host_name) = '".strtolower($keyword)."'" ;
					$str_host[] = "lower(Temp.host_name) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.machine) = '".strtolower($keyword)."'" ;
					$str_host[] = "lower(Temp.machine) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.maker) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.maker) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.serialno) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.serialno) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.product_id) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.product_id) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.os_name) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.os_name) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.servicepack) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.servicepack) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.cpu_name) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.cpu_name) like '%".strtolower($keyword_like)."%'";
					//wangs end 20080202

					//	        $str_host = implode(' or ', $str_host);

					foreach ($Addition as $v){

						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." ='".$keyword."'";

					}
					foreach ($Addition as $v){

						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." like '%".$keyword_like."%'";

					}
					$str_host = implode(' or ', $str_host);
					$condition_tem[] = "(" . $str_host. ")";

				}

				if($link_keyword != ""){

					//$keyword = urldecode($link_keyword);
					$keyword = $this->Lv->spec_char_dbm($link_keyword);

					$str_host = array();

					$str_host[] = "Temp.machine = '".$keyword."'" ;

					$str_host[] = "Temp.maker = '".$keyword."'";

					$str_host[] = "Temp.os_name = '".$keyword."'";

					$str_host[] = "Temp.servicepack = '".$keyword."'";

					$str_host[] = "Temp.cpu_name = '".$keyword."'";

					/* add zhaoli 20070913 10:20 */

					foreach ($Addition as $v){

						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." ='".$keyword."'";

					}
					$str_host = implode(' or ', $str_host);

					$condition_tem[] = "(" . $str_host. ")";
				}

				$asso_tem = array(	);
				$tem_crit = "	Temp.host_name as Temp__host_name,
							Temp.host_id as Temp__host_id,
							Temp.hardware_id as Temp__hardware_id,
							Temp.machine as Temp__machine,
							Temp.maker as Temp__maker,
							Temp.serialno as Temp__serialno,
							Temp.cpu_name as Temp__cpu_name,
							Temp.cpu_number as Temp__cpu_number,
							Temp.hrdmem_capacity as Temp__hrdmem_capacity,
							Temp.hrdphydsk_allspace as Temp__hrdphydsk_allspace,
							Temp.hrdphydsk_freespace as Temp__hrdphydsk_freespace,
							Temp.hrdphydsk_late as Temp__hrdphydsk_late,
							Temp.os_name as Temp__os_name,
							Temp.servicepack as Temp__servicepack,
							Temp.log_time as Temp__log_time,
							Temp.product_id as Temp__product_id,
							Temp.activation as Temp__activation,
							Temp.description as Temp__description";		



				foreach ($Addition as $v){

					$f =$v['Addition']['addition_name'];
					$a =','.'Temp.'.$f.' as Temp__'.$f;
					$tem_crit = $tem_crit.$a;
				}
				$tem_criteria =	array($tem_crit);
				$this->Pagination->show = 8;
				list($order,$limit,$page) = $this->Pagination->init($condition_tem, null, array('ajaxDivUpdate'=>'view', 'url'=>'/assets_mng_hdws/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso_tem), 'sortBy' => $this->Lv->sortBy('Temp.host_name')));
				$data = $this->Temp->findByAsso($condition_tem, $tem_criteria,$order,$limit,$page,$asso_tem);
				//    echo "================================";
				//xinw start 20080428
				$data_csv= $this->Temp->findByAsso($condition_tem, $tem_criteria,$order,null,null,$asso_tem);
				//xinw end 20080428
				$condition_tem1 = array("1=1" );
				$data1= $this->Temp->findByAsso($condition_tem1, $tem_criteria,$order,null,null,$asso_tem);

				$data_sum = count($data1);
				$data_search = count($data);
				if(!empty($sf_group)&&isset($Astsfw)){
					$data_sum = count($data1);
					$data_search = count($Astsfw);
				}

				//		 	debug($data,true);
				empty($data)? $data=array():$data;
				$this->set('data',$data);
				$this->set('data_sum',$data_sum);
				$this->set('data_search',$data_search);
				for($i=0;$i<count($data);$i++){
					// yzl start 2009/07/14 modify for LV20R1-228
					//$csvAS =round($data[$i]['Temp']['hrdphydsk_allspace']/1024/1024,1);
					//$csvFR=round($data[$i]['Temp']['hrdphydsk_freespace']/1024/1024,1);
					$csvAS =round($data[$i]['Temp']['hrdphydsk_allspace']/1024/1024/1024,1);
					$csvFR=round($data[$i]['Temp']['hrdphydsk_freespace']/1024/1024/1024,1);
					// yzl end 2009/07/14 modify for LV20R1-228
					$csvCP =round($data[$i]['Temp']['hrdmem_capacity']/1024,1);

					$data[$i]['Temp']['hrdphydsk_allspace']!==null&&$data[$i]['Temp']['hrdphydsk_allspace']!==""?$data[$i]['Temp']['hrdphydsk_allspace']=$csvAS:$data[$i]['Temp']['hrdphydsk_allspace']=null;
					$data[$i]['Temp']['hrdphydsk_freespace']!==null&&$data[$i]['Temp']['hrdphydsk_freespace']!==""?$data[$i]['Temp']['hrdphydsk_freespace']=$csvFR:$data[$i]['Temp']['hrdphydsk_freespace']=null;
					$data[$i]['Temp']['hrdmem_capacity']!==null&&$data[$i]['Temp']['hrdmem_capacity']!==""?$data[$i]['Temp']['hrdmem_capacity']=$csvCP:$data[$i]['Temp']['hrdmem_capacity']=null;

				}
				
				// yzl start 2009/07/14 modify for LV20R1-228
				for($i=0;$i<count($data_csv);$i++){
					$data_csv[$i]['Temp']['hrdphydsk_allspace'] = round($data_csv[$i]['Temp']['hrdphydsk_allspace']/1024/1024/1024,1);
					$data_csv[$i]['Temp']['hrdphydsk_freespace'] = round($data_csv[$i]['Temp']['hrdphydsk_freespace']/1024/1024/1024,1);
					$data_csv[$i]['Temp']['hrdmem_capacity'] = round($data_csv[$i]['Temp']['hrdmem_capacity']/1024,1);
				}
				// yzl end 2009/07/14 modify for LV20R1-228
				if($type =='csv')
				{
					//debug($data,true);
					//xinw start 20080428
					$this->csvdown($data_csv,$csv_result1);exit;
					//xinw end 20080428
				}
				//yuanxiaojun start 20080402
				if($type=='csv2'){
					$this->csvdown2($data_csv,$csv_result1);exit;
				}
				//yuanxiaojun end 20080402

	}// end search
	function lists(){
		//debug($this->data);
		if(!empty($this->data)){
			$groupid = $this->data['Group']['groupname'] ;
		}
		else{
			$groupid =$this->_getUserGroup();
		}

			$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

			// yzl start 2009/07/14 modify for LV20R1-228
			/*
			$feld="        			 id serial,
						         host_id integer,
						         hardware_id integer,
						         host_name varchar(40),
						         machine varchar(256),
						         maker varchar(256),
						         serialno varchar(256),
						         cpu_name varchar(127),
						         cpu_number integer,
						         hrdmem_capacity integer,
						         hrdphydsk_allspace integer,
						         hrdphydsk_freespace integer,
						         hrdphydsk_late integer,
						         os_name varchar(128) NULL,
						         servicepack varchar(200) NULL,
						         product_id varchar(100) NULL,
						         activation smallint NULL";
			*/
			$feld="        		 id serial,
						         host_id integer,
						         hardware_id integer NULL,
						         host_name varchar(40),
						         machine varchar(256) NULL,
						         maker varchar(256) NULL,
						         serialno varchar(256) NULL,
						         cpu_name varchar(127) NULL,
						         cpu_number integer NULL,
						         hrdmem_capacity integer NULL,
						         hrdphydsk_allspace DECIMAL(38,0) NULL,
						         hrdphydsk_freespace DECIMAL(38,0) NULL,
						         hrdphydsk_late integer NULL,
						         os_name varchar(128) NULL,
						         servicepack varchar(200) NULL,
								 log_time DATETIME default NULL,
						         product_id varchar(100) NULL,
						         activation smallint NULL,
								 description varchar(256) NULL";			
			// yzl end 2009/07/14 modify for LV20R1-228

			foreach ($Addition as $v){

				$f =$v['Addition']['addition_name'];
				$a =','.$f.' varchar(200) NULL';
				$feld = $feld.$a;

			}

			$result = $this->Host->query('CREATE TEMPORARY TABLE temppsoptusers ('.$feld.')');


			if($result === false){
				debug("CREATE TEMPORARY TABLE failed!", true);
			}
			$group_0=$this->_getUserGroup();
			$this->set('group_0',$group_0);
			$this->layout='ajax';

			$this->set('Addition',$Addition);
			//-------------sfws--end-------//

			//2007-09-20 zhaoli 16:22
			$Hostasso = array(
			'Asthrd : asthrds : left' => array('Host.id = Asthrd.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id '),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id '),
			'Grpauth : grpauths : left' => array('Grpauth.group_id = Group.id '),
			);
			$groupBy =" Host.id,Asthrd.id" ;

			//	del by wq 	 $Host_criteria=array("Host.status!= 0 and Grpauth.org_grp_id=".$groupid,"GROUP BY" => $groupBy,);
			$Host_criteria=array();
			$Host_criteria[]= "Host.status in (".$this->data['Host']['status'].")" ;
			//$Host_criteria[]= "Host.status != 1" ;
			$Host_criteria[]= "Grpauth.org_grp_id = ".$groupid;
			if(isset($this->data['dt_check']['criteria']))
				$Host_criteria[]= $this->data['dt_check']['criteria'];
			$Host_criteria["GROUP BY"] = $groupBy;

			$Host_fields = array(
			'Host.id',
			'Asthrd.id',
			'Host.status',
			);

			$hosts = $this->Host->findByAsso($Host_criteria, $Host_fields, 'Host.id',null,null, $Hostasso);

			foreach ($hosts as $A_ID)
			{  //start foreach

				$asthrd_id = $A_ID['Asthrd']['id'];
				$host_id=$A_ID['Host']['id'];
				//------------host -----------------------
				if(empty($asthrd_id)) {
					$asthrd_id=0;
				}
				$Host_criteria=array("Asthrd.id  = $asthrd_id");

				$Host_fields = array(
				'Asthrd.id',
				'Asthrd.host_id',
				'Asthrd.machine',
				'Asthrd.maker',
				'Asthrd.serialno',
				'Asthrd.log_time',
				);


				$host_name= $this->Host->find("Host.id = " . $host_id, 'Host.host_name', null,1,null,-1);
				$host_name = $host_name['Host']['host_name'];
				/*if($A_ID['Host']['status'] == 3)
					$host_name .= __('old_postfix', true);*/

				$Hosts= $this->Asthrd->findAll($Host_criteria, $Host_fields, null,1,null,-1);

				isset($Hosts[0]['Asthrd']['id'])?$Hosts[0]['Asthrd']['id'] = $Hosts[0]['Asthrd']['id'] : $Hosts[0]['Asthrd']['id'] = 'NULL';
				isset($Hosts[0]['Asthrd']['machine'])?$Hosts[0]['Asthrd']['machine'] = "'{$Hosts[0]['Asthrd']['machine']}'" : $Hosts[0]['Asthrd']['machine'] ='NULL';
				isset($Hosts[0]['Asthrd']['maker'])?$Hosts[0]['Asthrd']['maker'] = "'{$Hosts[0]['Asthrd']['maker']}'" : $Hosts[0]['Asthrd']['maker'] ='NULL';
				isset($Hosts[0]['Asthrd']['serialno'])?$Hosts[0]['Asthrd']['serialno'] = "'{$Hosts[0]['Asthrd']['serialno']}'" : $Hosts[0]['Asthrd']['serialno'] ='NULL';
				isset($Hosts[0]['Asthrd']['log_time'])?$Hosts[0]['Asthrd']['log_time'] = "'{$Hosts[0]['Asthrd']['log_time']}'" : $Hosts[0]['Asthrd']['log_time'] ='NULL';

				//---------------- hrdcpu -----------------
			
				$Hrdcpu_fields = array(
				//                      'Asthrd.id',
				'Hrdcpu.id',
				'Hrdcpu.cpu_name',
				'count(Hrdcpu.cpu_name) as Hrdcpu__cpu_num'
				);
				$cpu_crit = array();
				$cpu_crit[]="Hrdcpu.hardware_id =$asthrd_id";
				$cpu_crit['GROUP BY']="Hrdcpu.cpu_name";
				$Hrdcpus = $this->Hrdcpu->findAll($cpu_crit,  $Hrdcpu_fields, 'Hrdcpu.id', 1, null, -1);
				isset($Hrdcpus[0]['Hrdcpu']['cpu_name'])?$Hrdcpus[0]['Hrdcpu']['cpu_name'] = "'{$Hrdcpus[0]['Hrdcpu']['cpu_name']}'":$Hrdcpus[0]['Hrdcpu']['cpu_name'] ='NULL';
				$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = $asthrd_id"),'count(*) as count',null,null,null ,0);
				isset($Hrdcpus_num1)&&$Hrdcpus_num1[0][0]['count']!=0?$Hrdcpus_num = $Hrdcpus_num1[0][0]['count'] :$Hrdcpus_num ='NULL';
				//---------------- hrdmem  -----------------

				$Hrdmem_fields = array(
				//                      'Asthrd.id',
				'sum(Hrdmem.capacity) AS Hrdmem__capacitys'
				);
				$Hrdmems = $this->Hrdmem->findByAsso(array("Hrdmem.hardware_id =$asthrd_id",'GROUP BY'=>'Hrdmem.hardware_id'), $Hrdmem_fields, null, null, null, array());

				isset($Hrdmems[0]['Hrdmem']['capacitys'])?$Hrdmems_capacitys = $Hrdmems[0]['Hrdmem']['capacitys']: $Hrdmems_capacitys = 'null';
				//-----------------hrdphydsk-------------

				$Hrdphydsk_fields = array(
				'sum(Hrdphydsk.allspace) AS Hrdphydsk__allspace',

				);
				$Hrdlogdsk_fields = array(
				'sum(Hrdlogdsk.freespace) AS Hrdlogdsk__freespace'
				);
				$Hrdphydsks = $this->Hrdphydsk->findByAsso(array("Hrdphydsk.hardware_id =$asthrd_id",'GROUP BY'=>'Hrdphydsk.hardware_id'), $Hrdphydsk_fields, null,null, null, array());
				$Hrdlogdsks = $this->Hrdlogdsk->findByAsso(array("Hrdlogdsk.hardware_id =$asthrd_id","Hrdlogdsk.drivetype != 4",'GROUP BY'=>'Hrdlogdsk.hardware_id'), $Hrdlogdsk_fields, null,null, null, array());

				isset($Hrdphydsks[0]['Hrdphydsk']['allspace']) ? $Hrdphydsks_allspace = $Hrdphydsks[0]['Hrdphydsk']['allspace'] :$Hrdphydsks_allspace ='null';
				isset($Hrdlogdsks[0]['Hrdlogdsk']['freespace']) ? $Hrdlogdsks_freespace = $Hrdlogdsks[0]['Hrdlogdsk']['freespace'] :$Hrdlogdsks_freespace ='null';

				$a=$Hrdphydsks_allspace;
				$b=$Hrdlogdsks_freespace;


				if(($a>$b)){
					$hrdphydsk_late=round(($b)/$a*100,1);

				}
				else{$hrdphydsk_late='null';}

				//astoses--
				$os_name = $this->Astose->find(array("Astose.hardware_id=$asthrd_id"),null,null,null,null,-1);
				$osname= $os_name['Astose']['os_name'];
				$servicepack= $os_name['Astose']['servicepack'];
				$product_id= $os_name['Astose']['product_id'];
				//$activation= $os_name['Astose']['activation'];
				isset($os_name['Astose']['activation']) ? $activation = "'{$os_name['Astose']['activation']}'":$activation ='null';
				// yaozl start 2009/09/01 modify for LV20R1-280
				if (strpos($osname,"2000")) {
					$activation = "2";
				}
				$description= $this->Lv->spec_char_dbm($os_name['Astose']['description']);
				// yaozl end 2009/09/01 modify for LV20R1-280
				//hstadt-
				$Hstadt_asso = array(
				'Host : hosts' =>array('Hstadt.host_id =Host.id')
				);

				$Hstadt_fields=array('Host.id',
				'Hstadt.id',
				'Hstadt.option1',
				'Hstadt.option2',
				'Hstadt.option3',
				'Hstadt.option4',
				'Hstadt.option5',
				'Hstadt.option6',
				'Hstadt.option7',
				'Hstadt.option8',
				'Hstadt.option9',
				'Hstadt.option10');
				$criteria_Hstadt=array("Hstadt.host_id=".$host_id);

				$result_Hstadt = $this->Hstadt->findByAsso($criteria_Hstadt,$Hstadt_fields , null, 1, null, $Hstadt_asso);
/*  				isset($result_Hstadt[0]['Hstadt']['option1']) ? $result_Hstadt[0]['Hstadt']['option1'] = $result_Hstadt[0]['Hstadt']['option1']:$result_Hstadt[0]['Hstadt']['option1'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option2']) ? $result_Hstadt[0]['Hstadt']['option2'] = $result_Hstadt[0]['Hstadt']['option2']:$result_Hstadt[0]['Hstadt']['option2'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option3']) ? $result_Hstadt[0]['Hstadt']['option3'] = $result_Hstadt[0]['Hstadt']['option3']:$result_Hstadt[0]['Hstadt']['option3'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option4']) ? $result_Hstadt[0]['Hstadt']['option4'] = $result_Hstadt[0]['Hstadt']['option4']:$result_Hstadt[0]['Hstadt']['option4'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option5']) ? $result_Hstadt[0]['Hstadt']['option5'] = $result_Hstadt[0]['Hstadt']['option5']:$result_Hstadt[0]['Hstadt']['option5'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option6']) ? $result_Hstadt[0]['Hstadt']['option6'] = $result_Hstadt[0]['Hstadt']['option6']:$result_Hstadt[0]['Hstadt']['option6'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option7']) ? $result_Hstadt[0]['Hstadt']['option7'] = $result_Hstadt[0]['Hstadt']['option7']:$result_Hstadt[0]['Hstadt']['option7'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option8']) ? $result_Hstadt[0]['Hstadt']['option8'] = $result_Hstadt[0]['Hstadt']['option8']:$result_Hstadt[0]['Hstadt']['option8'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option9']) ? $result_Hstadt[0]['Hstadt']['option9'] = $result_Hstadt[0]['Hstadt']['option9']:$result_Hstadt[0]['Hstadt']['option9'] =NULL;
				isset($result_Hstadt[0]['Hstadt']['option10']) ? $result_Hstadt[0]['Hstadt']['option10'] = $result_Hstadt[0]['Hstadt']['option10']:$result_Hstadt[0]['Hstadt']['option10'] =NULL;
 */
				$insert = "INSERT INTO temppsoptusers VALUES(null,
		 {$A_ID['Host']['id']},
		 {$Hosts[0]['Asthrd']['id']},  
		 '{$this->Lv->spec_char_dbm($host_name)}', 
		 {$Hosts[0]['Asthrd']['machine']}, 
	     {$Hosts[0]['Asthrd']['maker']},
		 {$Hosts[0]['Asthrd']['serialno']},
		 {$Hrdcpus[0]['Hrdcpu']['cpu_name']},
		 {$Hrdcpus_num},
		 {$Hrdmems_capacitys},
		 {$Hrdphydsks_allspace},
		 {$Hrdlogdsks_freespace},
         {$hrdphydsk_late},
		 '{$osname}',
		 '{$servicepack}',
		 {$Hosts[0]['Asthrd']['log_time']},
		 '{$product_id}',
		 {$activation},
		 '{$description}'";

				foreach ($Addition as $v){
					$f =$v['Addition']['addition_name'];
					if(!empty($result_Hstadt[0]['Hstadt'][$f]))
					$insert = $insert.",'".$this->Lv->spec_char_dbm($result_Hstadt[0]['Hstadt'][$f])."'";
					else
					$insert = $insert.", null";
				}
				$insert = $insert.');';

				$this->Host->query($insert);
			}//end foreach

	} //end lists
	
	//PC一台
	function csvdown1($c = nul,$A=null,$csv_result){
		$Astsfws =$A;
		$Asthrds_id=$c;
		$criteria_hdw[] = "Asthrd.id=".$Asthrds_id;

		//wangs start 20080222
		$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds_id;
		$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
		$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('count(cpu_name) as cpu_num,cpu_name'), "Hrdcpu.id", 1, null, -1);
		//wangs end 20080222

		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

		$asso3 = array(
		'Hrdcpu : hrdcpus' => array('Hrdcpu.hardware_id = Asthrd.id '),
		) ;
		//		$Hrdcpus = $this->Asthrd->findByAsso($criteria_hdw,array('cpu_name'), null, null, null, $asso3);
		$this->set('Hrdcpu',$Hrdcpus);

		$asso4 = array(
		'Hrdmem : hrdmems' => array('Hrdmem.hardware_id = Asthrd.id '),
		) ;
		$Hrdmems = $this->Asthrd->findByAsso($criteria_hdw,array('capacity'), null, null, null, $asso4);
		$this->set('Hrdmem',$Hrdmems);

		$asso5 = array(
		'Hrdphydsk : hrdphydsks' => array('Hrdphydsk.hardware_id = Asthrd.id '),
		) ;
		$Hrdphydsks = $this->Asthrd->findByAsso($criteria_hdw,array('allspace','type'), null, null, null, $asso5);
		$this->set('Hrdphydsk',$Hrdphydsks);

		$asso6 = array(
		'Hrdmnt : hrdmnts' => array('Hrdmnt.hardware_id = Asthrd.id '),
		) ;
		$Hrdmnts = $this->Asthrd->findByAsso($criteria_hdw,array('monitor_name','adapterram','horizontal','vertical','bits'), null, null, null, $asso6);
		$this->set('Hrdmnt',$Hrdmnts);

		$asso7 = array(
		'Hrdnic : hrdnics' => array('Hrdnic.hardware_id = Asthrd.id '),
		) ;
		$Hrdnics = $this->Asthrd->findByAsso($criteria_hdw,array('nic_name','enableflg','mac_address','ip_address'), null, null, null, $asso7);
		$this->set('Hrdnic',$Hrdnics);

		$asso8 = array(
		'Hrddrv : hrddrvs' => array('Hrddrv.hardware_id = Asthrd.id '),
		) ;
		$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
		//        $Hrddrvs = $this->Asthrd->findByAsso($criteria_hdw, "Hrddrv.driver_name||'('||Hrddrv.driver||')' AS Hrddrv__driver_name", null, null, null, $asso8);//2007-11-27 変更zhaoli
		$Hrddrvs = $this->Asthrd->findByAsso($criteria_hdw, $Hrddrvs_fields, null, null, null, $asso8);//2007-11-27 変更zhaoli
		for($i=0;$i<count($Hrddrvs);$i++){
			if(!empty($Hrddrvs[$i]['driver_name']))
				$Hrddrvs[$i]['driver_name']= $Hrddrvs[$i]['driver_name'].'('.$Hrddrvs[$i]['driver'].')';
		}
		
		$this->set('Hrddrv',$Hrddrvs);
		// 		debug($Hrddrvs,true);
		// 		debug($Hrdnics,true);

		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");

		$array = array(	  "",
		""=>__('hdw_00',true),//□ ハードウェア台帳
		//									"□ ハードウェア情報",
		"Host/host_name"=>__('computer_name',true),//"コンピューター",
		"Asthrd/machine"=>__('machine',true),//"機種",
		"Asthrd/maker"=>__('maker',true),//"メーカー",
		"Asthrd/serialno"=>__('serialnumber',true));//"シリアルナンバー");
		if(!empty($Hrdcpus)){
			$f=array();
			for($i=0;$i<count($Hrdcpus);$i++){
				//$a='Hrdcpu/cpu_name'.$i;
				//$f='cpu '.$i;
				//$array[$a] =$f;
				$array['Hrdcpu/cpu_name'.$i] = __('CPU', true);
				//$array['Hrdcpu/cpu_num'.$i] = __('CPU_no', true);
			}
		}
		$array['Hrdmem/capacity'] =__('Hrdmem',true);//"メモリ総容量";

		if(!empty($Hrdmems)){
			$f=array();
			for($i=0;$i<count($Hrdmems);$i++){
				$a='Hrdmem/capacity'.$i;
				$f='DIMM '.$i;
				$array[$a] =$f;
			}
		}
		$array['Hrdphydsk/allspace_freespace'] = __('HDD_03',true);//"HDD(総容量/空き容量)";

		if(!empty($Hrdphydsks)){
			$f=array();
			for($i=0;$i<count($Hrdphydsks);$i++){
				$a='Hrdphydsk/allspace'.$i;
				$f=__('drive',true).$i;
				$array[$a] =$f;
			}
		}

		$array['Hrddrv/driver_name'] = __('scannerdrive',true).'('.__('type',true).')';//"光学ドライブ(型番)";

		if(!empty($Hrddrvs)){
			$f=array();
			for($i=0;$i<count($Hrddrvs);$i++){
				$a='Hrddrv/driver_name'.$i;
				$f=__('scannerdrive',true).$i;
				$array[$a] =$f;
			}
		}

		$array['Hrddrv/driver_name'] = __('scannerdrive',true).'('.__('type',true).')';//"光学ドライブ(型番)";

		if(!empty($Hrdmnts)){
			$f=array();
			for($i=0;$i<count($Hrdmnts);$i++){
				$a='Hrdmnt/monitor_name'.$i;
				$b='Hrdmnt/adapterram'.$i;
				$c='Hrdmnt/horizontal.vertical.bits'.$i;

				//							    $f='ビデオコントローラ'.$i;
				//							    $g='VRAMサイズ ID'.$i;
				//							    $h='画面の解析度'.$i;
				$f=__('videocontroller',true).$i;
				$g=__('size_Id',true).$i;
				$h=__('Analyticallevelofscreen',true).$i;
				$array[$a] =$f;
				$array[$b] =$g;
				$array[$c] =$h;
			}
		}

		if(!empty($Hrdnics)){
			$f=array();
			for($i=0;$i<count($Hrdnics);$i++){
				$a='Hrdnic/nic_name'.$i;
				$b='Hrdnic/mac_address'.$i;
				$c='Hrdnic/ip_address'.$i;

				$f=__('Networkinterfacecard',true).$i;
				$g=__('Address_00',true).$i;
				$h=__('ip_Address',true).$i;
				$array[$a] =$f;
				$array[$b] =$g;
				$array[$c] =$h;

			}
		}
		$array[] ='';
		$array[] ='□ '.__('OSinfo',true);//'□ オペレーティングシステム情報';
		$array['Astose/os_name'] =__('OS',true).'('.__('SP',true).')';
		$array['Astose/product_id'] =__('Product ID',true);//"Product ID";
		$array['Astose/install_time'] =__('Installationdate',true);//"インストール日時";
		$array['Astose/activation'] =__('ActiItionexecution',true);//"アクティべイション実施";
		$array['Astose/user_name'] =__('HardUser',true);//"使用者";
		$array['Astose/organization'] =__('Organizationname',true);//"組織名";
		$array['Astose/description'] =__('Descriptionname',true);//"コンピューターの説明";
		$array['Astact/account_name'] =__('Accountlist',true);//"アカウント一覧";
		$array[] ='';

		$array[] ='□ '.__('assetsinfo',true);//'□ 任意設定情報';
		if(!empty($Addition)){
			foreach ($Addition as $key => $output){
				/*		   */
				$diplay = decbin($output['Addition']['display']);

				// zhangs start 20080218
				// debug($array,true);
				// debug($csv_result,true);
				// zhangs end 20080218
				if(strlen($diplay)==2){
					$flag=0;
				}
				elseif(strlen($diplay)==3){
					if(substr($diplay, 0,1)==1){
						$flag=1;   }
				}

				if($flag==1){
					/*		   */
					$a= $output['Addition']['addition_name'];
					$b = $output['Addition']['addition_content'];
					$f = "Hstadt/".$a;
					$array[$f]=$b;
					/*		   */
				}
				/*		   */
			}
		}
		$array[] ='';
		$array[] ='□ '.__('Installationsoftwarelist',true);//'□ インストールソフトウェアリスト';
		//
		$array_cols = array(
		//		              ""=> "□ インストールソフトウェアリスト",
		"Astsfw/software_name"=>__('Softwarename',true),//"ソフトウェア名",
		"Astsfw/version"=>__('version',true),//"バージョン",
		"Astsfw/maker"=>__('maker',true),//"メーカー",
		"Astsfw/licence_code"=>__('Licenseinfo',true));//"ライセンス情報");// 変更

		$csv->special_search_title=$array;
		$csv->special_cols=$array_cols;
		$csv->sendCSVFile($Astsfws,$csv_result,__('hardwareinfo',true));

	}

	//CSVダウンロード(詳細）     yuanxiaojun start 20080410　
	function csvdown2($data,$csv_result1){
		$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);

		$csv_result=array();
		$j =0;
		for($m=0;$m<count($data);$m++){
			$id=$data[$j]['Temp']['host_id'];
			$Hosts= $this->Host->find("Host.id = ".$id, 'Host.host_name', null,1,null,-1);
			$criteria_hostId = "Asthrd.host_id=".$id."";
			$Asthrd_id = $this->Asthrd->find($criteria_hostId,'Asthrd.id');
			///================= asthrd id----------

			$Hstadt_asso = array(
			'Hstadt : hstadts' =>array('Hstadt.host_id =Host.id'),
			);

			$Hstadt_fields=array('Host.id',
			'Hstadt.id',
			'Hstadt.option1',
			'Hstadt.option2',
			'Hstadt.option3',
			'Hstadt.option4',
			'Hstadt.option5',
			'Hstadt.option6',
			'Hstadt.option7',
			'Hstadt.option8',
			'Hstadt.option9',
			'Hstadt.option10');

			$criteria_Hstadt=array("Hstadt.host_id=".$id);

			$result_Hstadt = $this->Host->findByAsso($criteria_Hstadt,$Hstadt_fields , null, null, null, $Hstadt_asso);
			!empty($result_Hstadt)?$this->set('result_Hstadt',$result_Hstadt):$this->set('result_Hstadt',"");
			!empty($result_Hstadt[0]['Hstadt']['option1'])?$result_Hstadt[0]['Hstadt']['option1'] = $result_Hstadt[0]['Hstadt']['option1']:$result_Hstadt[0]['Hstadt']['option1'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option2'])?$result_Hstadt[0]['Hstadt']['option2'] = $result_Hstadt[0]['Hstadt']['option2']:$result_Hstadt[0]['Hstadt']['option2'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option3'])?$result_Hstadt[0]['Hstadt']['option3'] = $result_Hstadt[0]['Hstadt']['option3']:$result_Hstadt[0]['Hstadt']['option3'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option4'])?$result_Hstadt[0]['Hstadt']['option4'] = $result_Hstadt[0]['Hstadt']['option4']:$result_Hstadt[0]['Hstadt']['option4'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option5'])?$result_Hstadt[0]['Hstadt']['option5'] = $result_Hstadt[0]['Hstadt']['option5']:$result_Hstadt[0]['Hstadt']['option5'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option6'])?$result_Hstadt[0]['Hstadt']['option6'] = $result_Hstadt[0]['Hstadt']['option6']:$result_Hstadt[0]['Hstadt']['option6'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option7'])?$result_Hstadt[0]['Hstadt']['option7'] = $result_Hstadt[0]['Hstadt']['option7']:$result_Hstadt[0]['Hstadt']['option7'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option8'])?$result_Hstadt[0]['Hstadt']['option8'] = $result_Hstadt[0]['Hstadt']['option8']:$result_Hstadt[0]['Hstadt']['option8'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option9'])?$result_Hstadt[0]['Hstadt']['option9'] = $result_Hstadt[0]['Hstadt']['option9']:$result_Hstadt[0]['Hstadt']['option9'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option10'])?$result_Hstadt[0]['Hstadt']['option10'] = $result_Hstadt[0]['Hstadt']['option10']:$result_Hstadt[0]['Hstadt']['option10'] =NULL;

			if($Asthrd_id['Asthrd']['id']){
				$condition = array();
				$condition[] ="Asthrd.id  = ".$Asthrd_id['Asthrd']['id'];

				$condition['GROUP BY']="Asthrd.id,Asthrd.machine,Asthrd.maker,Asthrd.serialno";
				$fields_Asthrd = array(
				'Asthrd.id',
				'Asthrd.machine',
				'Asthrd.maker',
				'Asthrd.serialno');
				$Asthrds = $this->Asthrd->find($condition, $fields_Asthrd, 'Asthrd.id',null,null, -1);
				$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
				$Hrddrvs = $this->Hrddrv->findAll(array("Hrddrv.hardware_id" => $Asthrds['Asthrd']['id']), $Hrddrvs_fields, null, null, null, null);//2007-11-27 変更 ?zhaoli
				$asso_Astacts = array( 'Astose : astoses' => array('Astact.os_id = Astose.id'), ) ;
				$criteria_ast=array();
				$criteria_ast[]="Astose.hardware_id=".$Asthrds['Asthrd']['id'];
				$criteria_ast['GROUP BY']="Astose.hardware_id,Astact.account_name";

				$Astacts = $this->Astact->findByAsso($criteria_ast,array('Astact.account_name'), null, null, null, $asso_Astacts);
				$fields_Astose = array(
				'Astose.os_name',
				'Astose.servicepack',
				'Astose.product_id',
				'Astose.install_time',
				'Astose.activation',
				'Astose.user_name',
				'Astose.organization',
				'Astose.description',
				);
				$criteria_Astoses=array("Astose.hardware_id" => $Asthrds['Asthrd']['id']);
				$Astoses = $this->Astose->find($criteria_Astoses, $fields_Astose, 'Astose.id', null, null,null);

				$criteria_cpu=array();
				$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'];
				$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
				$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('count(cpu_name) as cpu_num,cpu_name'), "Hrdcpu.id", 1, null, -1);

				$Hrdmems = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('capacity'), null, null, null, -1);
				$Hrdmems1 = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(capacity) as Hrdmem__capacity'), null, null, null, -1);
				$Hrdphydsks = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('allspace','type'), null, null, null, -1);
				$Hrdphydsks1 = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(allspace) as Hrdphydsk__allspace'), null, null, null, -1);
				$Hrdlogdsks1 = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" =>$Asthrds['Asthrd']['id'],"Hrdlogdsk.drivetype != 4"),array('SUM(freespace) as Hrdlogdsk__freespace'), null, null, null, -1);
				$Hrdmnts = $this->Hrdmnt->findAll(array("Hrdmnt.hardware_id" => $Asthrds['Asthrd']['id']),array('monitor_name','adapterram','horizontal','vertical','bits'), null, null,null,-1);

				$criteria_Hrdnics=array("Hrdnic.hardware_id" => $Asthrds['Asthrd']['id']);
				$Hrdnics = $this->Hrdnic->findAll($criteria_Hrdnics,array('nic_name','enableflg','mac_address','ip_address'), null, null, null,-1);

				//--csv--  array
				//コンピュータ名"
				!empty($Hosts['Host']['host_name'])?$csv_result[$j]['Host']['host_name']=$Hosts['Host']['host_name']:$csv_result[$j]['Host']['host_name'] =null;
				//機種名









				!empty($Asthrds['Asthrd']['machine'])?$csv_result[$j]['Asthrd']['machine']=$Asthrds['Asthrd']['machine']:$csv_result[$j]['Asthrd']['machine'] =null;
				//メーカー名









				!empty($Asthrds['Asthrd']['maker'])?$csv_result[$j]['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result[$j]['Asthrd']['maker'] =null;
				//シリアルナンバー
				!empty($Asthrds['Asthrd']['serialno'])?$csv_result[$j]['Asthrd']['serialno']= $Asthrds['Asthrd']['serialno']:$csv_result[$j]['Asthrd']['serialno'] =null;
				//cpu
				if(empty($Hrdcpus)){
					//$csv_result[$j]['Hrdcpu']['cpu_name.cpu_num0']=null;
					$csv_result[$j]['Hrdcpu']['cpu_name']=null;
					$csv_result[$j]['Hrdcpu']['cpu_total']=null;
				}else{
					$csv_result[$j]['Hrdcpu']['cpu_name']=$Hrdcpus[0][0]['cpu_name'];
					$csv_result[$j]['Hrdcpu']['cpu_total']=null;
				/*	for($i=0;$i<count($Hrdcpus);$i++){
						$f='cpu_name.cpu_num'.$i;
						!empty($Hrdcpus[$i])?$csv_result[$j]['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name'].'×'.$Hrdcpus[$i][0]['cpu_num']:$csv_result[$j]['Hrdcpu'][$f] =null;
					}*/
				}
				$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id']),'count(*) as count',null,null,null ,0);
				if(empty($Hrdcpus_num1))
					$csv_result[$j]['Hrdcpu']['cpu_total'] = "";
				else
					$csv_result[$j]['Hrdcpu']['cpu_total'] = $Hrdcpus_num1[0][0]['count'];
				
				//メモリ（総容量）







				!empty($Hrdmems1[0]['Hrdmem']['capacity'])?$csv_result[$j]['Hrdmem']['capacity']=round($Hrdmems1[0]['Hrdmem']['capacity']/1024,1).'MB':$csv_result[$j]['Hrdmem']['capacity']=null;
				//DIMM
				for($i=0;$i<count($Hrdmems);$i++){
					$f='capacity'.$i;
					$capacity_1 = round($Hrdmems[$i]['Hrdmem']['capacity']/1024,1).'MB';
					!empty($Hrdmems[$i]['Hrdmem']['capacity'])?$csv_result[$j]['Hrdmem'][$f]=$capacity_1: $csv_result[$j]['Hrdmem'][$f]=null;
				}
				$HrdmemsStart=MEMORY_NAME;
				if(count($Hrdmems)<$HrdmemsStart){
					for($i=count($Hrdmems);$i<$HrdmemsStart;$i++){
						$f='capacity'.$i;
						$capacity_1 = null;
						$csv_result[$j]['Hrdmem'][$f]=$capacity_1;
					}
				}
				// yzl start 2009/07/14 modify for LV20R1-228
				//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024,1).'GB/':$allspace_0 =null;
				//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024,1).'GB':$freespace_0 =null;
				!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB/':$allspace_0 =null;
				!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024/1024,1).'GB':$freespace_0 =null;
				// yzl end 2009/07/14 modify for LV20R1-228
				//HDD(総容量/空き容量)
				$csv_result[$j]['Hrdphydsk']['allspace_freespace']=$allspace_0.$freespace_0;
				//ドライブ







				for($i=0;$i<count($Hrdphydsks);$i++){
					$f='allspace'.$i;
					// yzl start 2009/07/14 modify for LV20R1-228
					//!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result[$j]['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024,1).'GB':$csv_result[$j]['Hrdphydsk'][$f]=null;
					!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result[$j]['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB':$csv_result[$j]['Hrdphydsk'][$f]=null;
					// yzl end 2009/07/14 modify for LV20R1-228
				}
				$HrdphydsksStart=ALLSPACE;
				if(count($Hrdphydsks)<$HrdphydsksStart){
					for($i=count($Hrdphydsks);$i<$HrdphydsksStart;$i++){
						$f='allspace'.$i;
						$allspace_1 = null;
						$csv_result[$j]['Hrdphydsk'][$f]=$allspace_1;
					}
				}
				//光学ドライブ(型番)

				if(!empty($Hrddrvs[0]['Hrddrv']['driver_name']))
					$csv_result[$j]['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name'].'('.$Hrddrvs[0]['Hrddrv']['driver'].')';
				else
					$csv_result[$j]['Hrddrv']['driver_name']=null;

				$HrddrvsStart=DRIVER_NAME;
				for($i=0;$i<count($Hrddrvs);$i++){
					$f='driver_name'.$i;
					if(!empty($Hrddrvs[$i]['Hrddrv']['driver_name']))
						$csv_result[$j]['Hrddrv'][$f]= $Hrddrvs[$i]['Hrddrv']['driver_name'].'('.$Hrddrvs[$i]['Hrddrv']['driver'].')';
					else
						$csv_result[$j]['Hrddrv'][$f]=null;

				}
				if(count($Hrddrvs)<$HrddrvsStart){
					for($i=count($Hrddrvs);$i<$HrddrvsStart;$i++){
						$f='driver_name'.$i;
						$driver_name_1 = null;
						$csv_result[$j]['Hrddrv'][$f]=$driver_name_1;
					}
				}
				//ビデオコントローラ,VRAMサイズ , 画面の解析度
				for($i=0;$i<count($Hrdmnts);$i++){
					$f='monitor_name'.$i;
					$g='adapterram'.$i;
					$h='horizontal.vertical.bits'.$i;
					$adapterram_0 =round($Hrdmnts[$i] ['Hrdmnt']['adapterram']/1024,1);

					!empty($Hrdmnts[$i]['Hrdmnt']['monitor_name'])? $csv_result[$j]['Hrdmnt'][$f]=$Hrdmnts[$i]['Hrdmnt']['monitor_name']:$csv_result[$j]['Hrdmnt'][$f]=null;
					!empty($Hrdmnts[$i]['Hrdmnt']['adapterram'])? $csv_result[$j]['Hrdmnt'][$g]=round($Hrdmnts[$i]['Hrdmnt']['adapterram']/1024,1).'MB':$csv_result[$j]['Hrdmnt'][$g]=null;

					($Hrdmnts[$i]['Hrdmnt']['horizontal']) !=null? $csv_result[$j]['Hrdmnt'][$h]=$Hrdmnts[$i]['Hrdmnt']['horizontal'].'*'.$Hrdmnts[$i]['Hrdmnt']['vertical'].'('.$Hrdmnts[$i]['Hrdmnt']['bits'].'bit'.')':$csv_result[$j]['Hrdmnt'][$h]=null;

				}
				$HrdmntsStart=MONITOR_NAME;
				if(count($Hrdmnts)<$HrdmntsStart){
					for($i=count($Hrdmnts);$i<$HrdmntsStart;$i++){
						$f='monitor_name'.$i;
						$g='adapterram'.$i;
						$h='horizontal.vertical.bits'.$i;

						$csv_result[$j]['Hrdmnt'][$f]=null;
						$csv_result[$j]['Hrdmnt'][$g]=null;
						$csv_result[$j]['Hrdmnt'][$h]=null;
					}
				}

				//ネットワークインタフェースカード,MACアドレス,IPアドレス
				for($i=0;$i<count($Hrdnics);$i++){
					$f='nic_name'.$i;
					$g='mac_address'.$i;
					$h='ip_address'.$i;
					if($Hrdnics[$i]['Hrdnic']['enableflg']==0){
						$enable=__('nouse',true);
					}else{
						$enable=__('use',true);}
						!empty($Hrdnics[$i]['Hrdnic']['nic_name']) ?$csv_result[$j]['Hrdnic'][$f] = $Hrdnics[$i]['Hrdnic']['nic_name'].'('.$enable.')':$csv_result[$j]['Hrdnic'][$f]=null;
						!empty($Hrdnics[$i]['Hrdnic']['mac_address']) ?$csv_result[$j]['Hrdnic'][$g] = $Hrdnics[$i]['Hrdnic']['mac_address']:$csv_result[$j]['Hrdnic'][$g]=null;
						!empty($Hrdnics[$i]['Hrdnic']['ip_address']) ? $csv_result[$j]['Hrdnic'][$h] = $Hrdnics[$i]['Hrdnic']['ip_address']:$csv_result[$j]['Hrdnic'][$h]=null;
				}
				$HrdnicsStart=NIC_NAME;
				if(count($Hrdnics)<$HrdnicsStart){
					for($i=count($Hrdnics);$i<$HrdnicsStart;$i++){
						$f='nic_name'.$i;
						$g='mac_address'.$i;
						$h='ip_address'.$i;

						$csv_result[$j]['Hrdnic'][$f]=null;
						$csv_result[$j]['Hrdnic'][$g]=null;
						$csv_result[$j]['Hrdnic'][$h]=null;
					}
				}

				//OS（SP),インストール日時
				if(!empty($Astoses['Astose']['os_name'])){
					if(!empty($Astoses['Astose']['servicepack']))
						$csv_result[$j]['Astose']['os_name']= $Astoses['Astose']['os_name'].'('.$Astoses['Astose']['servicepack'].')';
					else
						$csv_result[$j]['Astose']['os_name']= $Astoses['Astose']['os_name'];
				}else
					$csv_result[$j]['Astose']['os_name'] =null;

				!empty($Astoses['Astose']['product_id'])?$csv_result[$j]['Astose']['product_id']= $Astoses['Astose']['product_id']:$csv_result[$j]['Astose']['product_id'] =null;
				!empty($Astoses['Astose']['install_time'])?$csv_result[$j]['Astose']['install_time']= $Astoses['Astose']['install_time']:$csv_result[$j]['Astose']['install_time'] =null;
				isset($Astoses['Astose']['activation'])?$Astose_activation= $Astoses['Astose']['activation'] :$Astose_activation =null;

				//アクティべイション実施
				//sunhy start 2009/05/06 modify for LV20R1-257
				/*if ($Astose_activation == '0') {
					$Astose_activation='○';
				}
				if($Astose_activation=='1'){
					$Astose_activation='×';
				}*/
				// yaozl start 2009/09/01 modify for LV20R1-280
				/*
				if ($Astose_activation == '1') {
					$Astose_activation='○';
				}
				if($Astose_activation=='0'){
					$Astose_activation='×';
				}
				*/				
				if ($Astose_activation == '0') {
					$Astose_activation='○';
				}
				if($Astose_activation=='1'){
					$Astose_activation='×';
				}
				if (strpos($Astoses['Astose']['os_name'],"2000")) {
					$Astose_activation = "-";
				}
				// yaozl end 2009/09/01 modify for LV20R1-280
				//sunhy end 2009/05/06 modify for LV20R1-257

				$this->set('Astose_activation',$Astose_activation);

				isset($Astoses['Astose']['activation'])?$csv_result[$j]['Astose']['activation']= $Astose_activation :$csv_result[$j]['Astose']['activation'] =null;
				//使用者








				!empty($Astoses)?$csv_result[$j]['Astose']['user_name']= $Astoses['Astose']['user_name']:$csv_result[$j]['Astose']['user_name'] =null;
				!empty($Astoses)?$csv_result[$j]['Astose']['organization']= $Astoses['Astose']['organization']:$csv_result[$j]['Astose']['organization'] =null;
				!empty($Astoses)?$csv_result[$j]['Astose']['description']= $Astoses['Astose']['description']:$csv_result[$j]['Astose']['description'] =null;

				$result_Astacts="";
				//アカウント一覧
				for($i=0;$i<count($Astacts);$i++){
					$f=$Astacts[$i]['Astact']['account_name'].'; ';
					!empty($Astacts[$i]['Astact']['account_name'])?$result_Astacts=$result_Astacts.$f:$result_Astacts=null;
				}

				$result_Astacts = substr($result_Astacts, 0, strlen($result_Astacts)-2);

				!empty($result_Astacts)?$csv_result[$j]['Astact']['account_name'] = $result_Astacts:$csv_result[$j]['Astact']['account_name']=null;

				if(!empty($Addition)&&!empty($result_Hstadt)){

					foreach ($Addition as  $key =>$v){
						$f =$v['Addition']['addition_name'];
						$b =$v['Addition']['addition_content'];

						!empty($f)? $csv_result[$j]['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result[$j]['Hstadt'][$f] =NULL;}

				}

			}
			//yzl start  2009/09/07 modify for LV20R1-280再
			else{//ハードウェア台帳にログの上がっていないPCの場合
				$csv_result[$j]['Host']['host_name'] = $data[$j]['Temp']['host_name'];
				$csv_result[$j]['Asthrd']['machine'] = null;
				$csv_result[$j]['Asthrd']['maker'] = null;
				$csv_result[$j]['Asthrd']['serialno'] = null;
				//$csv_result[$j]['Hrdcpu']['cpu_name.cpu_num0'] = null;
				$csv_result[$j]['Hrdcpu']['cpu_name'] = null;
				$csv_result[$j]['Hrdcpu']['cpu_total'] = null;
				$csv_result[$j]['Hrdmem']['capacity'] = "0MB";
				for($i = 0 ; $i <= 4; $i ++){
					$csv_result[$j]['Hrdmem']['capacity'.$i] = null;
				}
				$csv_result[$j]['Hrdphydsk']['allspace_freespace'] = "0GB/0GB";
				for($i = 0 ; $i <= 4; $i ++){
					$csv_result[$j]['Hrdphydsk']['allspace'.$i] = null;
				}
				$csv_result[$j]['Hrddrv']['driver_name']= null;
				for($i = 0 ; $i <= 4; $i ++){
					$csv_result[$j]['Hrddrv']['driver_name'.$i]= null;
				}
				$csv_result[$j]['Hrdmnt']['monitor_name0']= null;
				$csv_result[$j]['Hrdmnt']['monitor_name1']= null;
				$csv_result[$j]['Hrdmnt']['adapterram0']= null;
				$csv_result[$j]['Hrdmnt']['adapterram1']= null;
				$csv_result[$j]['Hrdmnt']['horizontal.vertical.bits0']= null;
				$csv_result[$j]['Hrdmnt']['horizontal.vertical.bits1']= null;
				for($i = 0 ; $i <= 14; $i ++){
					$csv_result[$j]['Hrdnic']['nic_name'.$i]= null;
					$csv_result[$j]['Hrdnic']['mac_address'.$i]= null;
					$csv_result[$j]['Hrdnic']['ip_address'.$i]= null;
				}
				$csv_result[$j]['Astose']['os_name'] = null;
				$csv_result[$j]['Astose']['product_id'] = null;
				$csv_result[$j]['Astose']['install_time'] = null;
				$csv_result[$j]['Astose']['activation'] = null;
				$csv_result[$j]['Astose']['user_name'] = null;
				$csv_result[$j]['Astose']['organization'] = null;
				$csv_result[$j]['Astose']['description'] = null;
				
				$csv_result[$j]['Astact']['account_name']= null;
				//拡張資産項目
				if(!empty($Addition)&&!empty($result_Hstadt)){
					foreach ($Addition as  $key =>$v){
						$f =$v['Addition']['addition_name'];
						$b =$v['Addition']['addition_content'];

						!empty($f)? $csv_result[$j]['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result[$j]['Hstadt'][$f] =NULL;
					}
				}

			}
			//yzl end  2009/09/07 modify for LV20R1-280再
			$j++;
		}

		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);
		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");
		$array_cols = array();
		$array['Host/host_name'] =__('computer_name',true);//コンピュータ名







		$array['Asthrd/machine'] =__('machine',true);//機種名







		$array['Asthrd/maker'] =__('makername',true);//メーカー名







		$array['Asthrd/serialno'] =__('serialnumber',true);//シリアルナンバー
		//$array['Hrdcpu/cpu_name.cpu_num0'] =__('CPU',true);//cpu
		$array['Hrdcpu/cpu_name'] =__('CPU',true);//cpu
		$array['Hrdcpu/cpu_total'] =__('CPU_no',true);//cpu
		$array['Hrdmem/capacity'] =__('Hrdmem_00',true);//メモリ（総容量)
		//DIMM
		$f=array();
		for($i=0;$i<$HrdmemsStart;$i++){
			$a='Hrdmem/capacity'.$i;
			$f='DIMM '.$i;
			$array[$a] =$f;
		}
		$array['Hrdphydsk/allspace_freespace'] =__('HDD_03',true);//HDD(総容量/空き容量)
		//ドライブ







		$f=array();
		for($i=0;$i<$HrdphydsksStart;$i++){
			$a='Hrdphydsk/allspace'.$i;
			$f=__('drive',true).$i;
			$array[$a] =$f;
		}
		//光学ドライブ(型番)
		$f=array();
		for($i=0;$i<$HrddrvsStart;$i++){
			$a='Hrddrv/driver_name'.$i;
			$f=__('scannerdrive',true).$i;
			$array[$a] =$f;
		}
		//ビデオコントローラ
		$f=array();
		for($i=0;$i<$HrdmntsStart;$i++){
			$a='Hrdmnt/monitor_name'.$i;
			$b='Hrdmnt/adapterram'.$i;
			$c='Hrdmnt/horizontal.vertical.bits'.$i;

			$f=__('videocontroller',true).$i;
			$g=__('size_Id',true).$i;
			$h=__('Analyticallevelofscreen',true).$i;
			$array[$a] =$f;
			$array[$b] =$g;
			$array[$c] =$h;
		}
		//ネットワークインタフェースカード







		$f=array();
		for($i=0;$i<$HrdnicsStart;$i++){
			$a='Hrdnic/nic_name'.$i;
			$b='Hrdnic/mac_address'.$i;
			$c='Hrdnic/ip_address'.$i;

			$f=__('Networkinterfacecard',true).$i;
			$g=__('Address_00',true).$i;
			$h=__('ip_Address',true).$i;
			$array[$a] =$f;
			$array[$b] =$g;
			$array[$c] =$h;

		}

		$array['Astose/os_name'] =__('OS',true).'('.__('SP',true).')';//OS(SP)
		$array['Astose/product_id'] =__('Product ID',true);//Product ID
		$array['Astose/install_time'] =__('Installationdate',true);//インストール日時







		$array['Astose/activation'] =__('ActiItionexecution',true);//アクティべイション実施
		$array['Astose/user_name'] =__('HardUser',true);//使用者







		$array['Astose/organization'] =__('Organizationname',true);//織名
		$array['Astose/description'] =__('Descriptionname',true);//織名
		$array['Astact/account_name'] =__('Accountlist',true);//アカウント一覧

		if(!empty($Addition)){
			foreach ($Addition as $key => $output){
				$diplaydata = $output['Addition']['display'];
				$diplay = decbin($output['Addition']['display']);

				if(($diplaydata==2)||$diplaydata==6){

					$flag=1;
				}
				else{
					$flag=0;
				}
				if(strlen($diplay)==3){
					if(substr($diplay, 0,1)==1){
						$flag=1;   }
				}

				if($flag==1){
					$a= $output['Addition']['addition_name'];
					$b = $output['Addition']['addition_content'];
					$f = "Hstadt/".$a;

					$array[$f]=$b;
				}

			}
		}


		$array_title[] =__('hdw_00',true);
		//xht start 2009/04/28 modify for LogvillageChinese
		$array_title[]='CSV_detail';
		//xht end 2009/04/28 modify for LogvillageChinese
		$csv->special_search_title=$array_title;
		$csv->special_cols=$array;
		$csv->sendCSVFile($csv_result,null,__('hardwareinfodetail',$retrun=true));

	}
	//yuanxiaojun end 20080410
	//CSVダウンロード(通常）
	function csvdown($data=nul,$uu){
		$csv_result1=$uu;
		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");

		$array = array(
		""=>__('hdw_00',true),//□ ハードウェア台帳
		"Temp/host_name"=>__('computer_name',true),//"コンピュータ名",
		"Temp/machine"=>__('machine',true),//"機種",
		"Temp/maker"=>__('makername',true),//"メーカー",
		"Temp/serialno"=>__('S/N',true),//"S/N",
		"Temp/cpu_name"=>__('CPU',true),//"CPU",
		"Temp/cpu_number"=>__('CPU_no',true),//"CPU数",
		"Temp/hrdmem_capacity"=>__('Hrdmem_00',true),//"メモリー総容量）MB",
		"Temp/hrdphydsk_allspace"=>__('HDD_00',true),//"HDD総容量）GB",
		"Temp/hrdphydsk_freespace"=>__('HDD_01',true),//"HDD空き容量）GB",
		"Temp/hrdphydsk_late"=>__('HDD_02',true),//"HDD残容量",
		"Temp/os_name"=>__('OS',true),//"OS",
		"Temp/servicepack"=>__('SP',true),//"SP",
		"Temp/product_id"=>__('Product ID',true),//"Product ID",
		"Temp/activation"=>__('activation',true),//"アクティベーション"
		"Temp/log_time"=>__('Logtime',true),//最終取得日時
		"Temp/description"=>__('description',true),
		);
		foreach ($Addition as $key => $output)
		{

			/*		   */
			$diplay = $output['Addition']['display'];


			if(($diplay==2)||$diplay==6){
				$flag=1;
			}
			else{
				$flag=0;
			}
			if($flag==1){
				/*		   */
				$a= $output['Addition']['addition_name'];
				$b = $output['Addition']['addition_content'];
				$f = "Temp/".$a;
				$array[$f]=$b;
				/*		   */
			}
			/*		   */
		}
		$csv->special_cols=$array;

		$csv->sendCSVFile($data,$csv_result1,__('hdw',$retrun=true));

	}

}//end class
?>