<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class AssetsNetscanController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Asthrd','Hrdnic','Macvendor','Netscan','Grpauth','Hstloghead','Host','Rlthstgrp','Group');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
			//	    		debug($_POST['forHideVar']);
			//	    		echo "forHideVar===".$_POST['forHideVar']."++++++1++++<br>";
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			//	    		debug($_POST['forHideVar1']);
			//	    		echo "forHideVar1===".$_POST['forHideVar1']."+++++2+++++<br>";
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($errorMessage = null)
	{
		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		
		$polllist = $this->Poll->generateList(null, null, null, '{n}.Poll.id', '{n}.Poll.poll_name', null);
		$polllist[0] =__('none_distribute', true);
		ksort($polllist);
		$this->set('plist',$polllist);
		
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	function listdriver($csv = null)
	{
		$this->layout="ajax";

		//入力データ取得
		$group = 1;//$this->data['Group']['group_name'];		
		$poll = $this->data['Poll']['id'];
		
		$keyword = $this->data['Netscan']['sinput'];
		$keyword2 = $this->Lv->spec_char_dbm($keyword);
		$keyword_pref = "";
		if(isset($this->data['Selector']['input_keyword_check'])){
			$keyword_pref = "%";
		}
//debug($this->data);

		//取得条件設定
		$asso = array(
			/*'Rlthstgrp : rlthstgrps : LEFT' => array('Netscan.group_id = Rlthstgrp.group_id'),
			'Asthrd : asthrds' => array('Asthrd.host_id = Rlthstgrp.host_id'),
			'Hrdnic : hrdnics : LEFT' => array('Asthrd.id = Hrdnic.hardware_id'),*/
			/*'Hrdnic : hrdnics : LEFT' => array('Netscan.mac_address = Hrdnic.mac_address'),
			'Asthrd : asthrds : LEFT' => array('Asthrd.id = Hrdnic.hardware_id'),
			'Rlthstgrp : rlthstgrps : LEFT' => array('Asthrd.host_id = Rlthstgrp.host_id'),*/
			'Macvendor : mac2vendor : left' => array('Macvendor.mac = substring(Netscan.mac_address, 1, 8)'),
		) ;
		
		$fields = array(
		'Netscan.id',
		'Netscan.group_id',
		'Netscan.ip_address',
		'Netscan.mac_address',
		'Netscan.ip_subnet',
		'Netscan.broadcast',
		'Netscan.pc_name',
		'Netscan.model_name',
		'Netscan.print_count',
		'Netscan.init_date',
		'Netscan.final_date',
		'Macvendor.vendor',
		//'Hrdnic.mac_address',
		//'Hrdnic.mac_address = Netscan.mac_address as Netscan__exists',
		);
		
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 

		$criteria[]="1=1";
	//	$criteria[]="Netscan.group_id in (".$group_ids.")";
		$criteria["GROUP BY"]="Netscan.ip_address";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Netscan->findByAsso($criteria, $fields, 'Netscan.ip_address', null, null, $asso);
		}else{
			$this->Pagination->show = 20;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_netscan/listdriver', 'modelClass'=>'Netscan', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy(
				'Netscan.ip_address',
				'Netscan.mac_address',
				'Netscan.ip_subnet',
				'Netscan.broadcast',
				'Netscan.pc_name',
				'Netscan.model_name',
				'Netscan.print_count',
				'Netscan.init_date',
				'Netscan.final_date',
				'Macvendor.vendor')));
			$Hrdprts = $this->Netscan->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
		}
		
		//HW台帳に同じMACがないか探す
		$asso2 = array(
				'Rlthstgrp : rlthstgrps' => array('Asthrd.host_id = Rlthstgrp.host_id'),
				'Hrdnic : hrdnics' => array('Asthrd.id = Hrdnic.hardware_id'),
			) ;
		$fields2 = array(
			'Rlthstgrp.group_id',
			'Hrdnic.ip_address',
		);
	//	$crit[]="Rlthstgrp.group_id in (".$group_ids.")";
		$crit[]="Hrdnic.ip_address is not null";
		$crit[]="Hrdnic.ip_address != ''";
		$Asthrds = $this->Asthrd->findByAsso($crit, $fields2, null, null, null, $asso2);
		//debug($Asthrds);
		foreach($Hrdprts as $i => $scan)
		{
			$Hrdprts[$i]['Netscan']['exists'] = "";
			foreach($Asthrds as $mac)
			{
				if($scan['Netscan']['ip_address'] == $mac['Hrdnic']['ip_address']){
					$Hrdprts[$i]['Netscan']['exists'] = 1;
					break;
				}
			}
		}
			
		if($csv == 'csv'){
			$this->csvdown($Hrdprts,1);exit;
		}
//debug($Hrdprts);

		$criteria2[]="1=1";
	//	$criteria2[]="Netscan.group_id in (".$group_ids.")";

		//$criteria2[]="Hrdprt.driver_name like '".$keyword_pref.$keyword2."%'";
		//$criteria2["GROUP BY"]="Hrdprt.hardware_id";
		$hardware_ids = $this->Netscan->findByAsso($criteria2, array("Netscan.id"), null, null, null, $asso);
		

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($hardware_ids));
		
		$this->set('group_id',$group);	
		$this->render('drivers');
	}

	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$criteria=" Group.id=".$group." ";
		$group_n= $this->Group->findAll($criteria);
		$parent = $group_n[0]["Group"]["parent_id"];
		
		$this->data['Csv']['group'] = $this->groupName($group);
		/*if($parent == 1){
			$this->data['Csv']['group'] = $this->groupName($group);
			$this->data['Csv']['group2'] = "";
		}else{
			$this->data['Csv']['group'] = $this->groupName($parent);
			$this->data['Csv']['group2'] = $this->groupName($group);
		}*/
		
/*		
		if(isset($this->data['Selector']['input_keyword_check']))
			$this->data['Csv']['check'] = __('csv_on',$retrun=true);
		else
			$this->data['Csv']['check'] = __('csv_off',$retrun=true);
		*/
			
		require_once( 'csv/DlFactory.php' );
		
		$filename="";

		foreach($data as $i => $d){
			if(!empty($d['Netscan']['exists']))
				$data[$i]['Netscan']['exists'] = '○';
		}

		$csv = DlFactory::create("assets_netscan");
		if($flag == 1){
			$array = array(
				'Netscan/ip_address'=>__('ip_address', $return = true),
				'Netscan/exists'=>"",
				'Netscan/mac_address'=>__('mac_address', $return = true),
				'Macvendor/vendor'=>__('nic_vendor', $return = true),
				'Netscan/ip_subnet'=>__('ip_subnet', $return = true),
				'Netscan/broadcast'=>__('broadcast', $return = true),
				'Netscan/pc_name'=>__('pc_name', $return = true),
				'Netscan/model_name'=>__('model_name', $return = true),
				'Netscan/print_count'=>__('print_count', $return = true),
				'Netscan/init_date'=>__('init_date', $return = true),
				'Netscan/final_date'=>__('final_date', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}/*
		elseif($flag == 2){
			$array = array(
				'Netscan/ip_address'=>__('ip_address', $return = true),
				'Netscan/mac_address'=>__('mac_address', $return = true),
				'Macvendor/vendor'=>__('nic_vendor', $return = true),
				'Netscan/ip_subnet'=>__('ip_subnet', $return = true),
				'Netscan/broadcast'=>__('broadcast', $return = true),
				'Netscan/pc_name'=>__('pc_name', $return = true),
				'Netscan/model_name'=>__('model_name', $return = true),
				'Netscan/print_count'=>__('print_count', $return = true),
				'Netscan/init_date'=>__('init_date', $return = true),
				'Netscan/final_date'=>__('final_date', $return = true),
			);
			
			$filename=__('csv_file2',$return=true);
		}*/

		$csv->special_cols=$array;
		//debug($data);
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	
	function groupName($group_id)
	{
		$criteria=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>