<?php
/*********************************************************************
*@filename 		system_grpset_schedules_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/10   modify for ASP4-036
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy       2009/05/31   modify for YBR-32
********************************************************************/
class SystemGrpsetSchedulesController extends AppController
{

	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv', 'GenerateFiles');
	var $uses=array('Poll','Group','License', 'Host','Rltshdmod','Somemod','Rlthstgrp','Rltgrpshd','Mailserver','Configure','Module','Grpshd','Grpauth','Hstloghead', 'Validation','Rltuserauth','Authority');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle = __('title',$return = true);
		//	if(isset($_POST['forHideVar1'])){
		//    		$this->set('forHideVar', $_POST['forHideVar1']);
		//	}
		//	else if(isset($_POST['forHideVar'])){
		//    		$this->set('forHideVar', $_POST['forHideVar']);
		//	}

		//		if(58&4)
		//		{
		//		echo $week=58&4;
		//		}
		//		$this->Configure->write('debug', 2);

		




		$this->set('netscan_conf', NETSCAN_CONF);
	}

	function index()
	{
		$ck= $this->requestAction("system_all_licenses/check_lic/");
		if($ck===false)
		{
			$this->GenerateFiles->hook_by_ps(0, array('schedule_stop'));
		}


		//    	$this->GenerateFiles->hook_by_ps(0, array('schedule_stop'));
		//    	$this->Configure->write('debug', 0);
		//    	$this->schedule();
		//$this->lic();
		$lists= $this->requestAction('/system_grpset_schedules/lists',array('return'));
		$this->set('lists',$lists);


	}
	function lists($do=null)
	{
		$this->layout='ajax';
		$err=null;

		//wangs start 20080227
		$Hosts= $this->Host->findAll(null, null, null,null,null,-1);
		$Polls= $this->Poll->findAll('poll_name is not null', null, null,null,null,-1);

		if (count($Hosts)>0) {
			$have_no_host=false;
		}else {
			$have_no_host=true;
		}
		$this->set('have_no_host', $have_no_host);

		if (count($Polls)>0) {
			$have_no_poll=false;
		}else {
			$have_no_poll=true;
		}
		$this->set('have_no_poll', $have_no_poll);
		//wangs end 20080227

		$conditions=array('1=1','GROUP BY'=>'Host.host_name');
		$asso = array(
		'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
		'Rlthstgrp : rlthstgrps' => array('Rltgrpshd.group_id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		//						'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
		//						'Module : modules' => array('Module.id =Rltshdmod.module_id'),
		);
		$datapc = $this->Grpshd->findByAsso($conditions, array('count(Host.id) as Host__count','Host.host_name'), null, null, null, $asso);


		//=================================1009

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			//					echo $data_lic;
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}
		//=================================1009
		//=================================1016  新規スケジュール登録可能なグループがありません

		if($do=='group_null')
		{
			$err[]=__('no_group',true);
			//			echo $do;
		}
		//=================================1016  新規スケジュール登録可能なグループがありません

		if($do=='d')
		{
			if(isset($this->params['form']['cbid']))
			{


				$condition="";
				foreach($this->params['form']['cbid'] as $key => $value){
					$condition.=$value.",";
				}
				$condition = substr($condition,0,-1);
				$did = $this->Grpshd->findAll(array('Grpshd.id in ('.$condition.')'), 'Grpshd.group_id', null, null, null, 0);


				foreach ($did as $delid)
				{
					$dgroup[]=$delid['Grpshd']['group_id'];
					//sunhy start 2009/06/04 modify for YBR-32
					//$this->Grpshd->del(array($this->params['form']['cbid']));
					foreach($this->params['form']['cbid'] as $grpschid){
						$this->Grpshd->del($grpschid);
					}
					$this->GenerateFiles->hook_by_group($delid['Grpshd']['group_id'], array('schedule'));
					//sunhy end 2009/06/04 modify for YBR-32
				}
				//    		debug($dgroup);
				//sunhy start 2009/06/04 modify for YBR-32
				//$this->Grpshd->del(array($this->params['form']['cbid']));
				//sunhy end 2009/06/04 modify for YBR-32

				//	    	$condition="";
				//			foreach($this->params['form']['cbid'] as $key => $value){
				//			    $condition.=$value.",";
				//			}
				//			$condition = substr($condition,0,-1);
				//
				//	    	$delconditions[]="sch_id in(".$condition.") ";
				//    		$this->Rltshdmod->deleteAll($delconditions);
				//    		$this->Rltgrpshd->deleteAll($delconditions);
				//sunhy start 2009/06/04 modify for YBR-32
				//$this->GenerateFiles->hook_by_group($dgroup, array('schedule'));
				//sunhy end 2009/06/04 modify for YBR-32
			}
			else
			{
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$err[]=__('no schedules',$return = true)."　".__('E-00200',$return = true);
				$err[]=__('groupSchedules',$return = true)."　".__('E-00200',$return = true);
				//xushanning end 2009/04/22   modify for LogvillageChinese
			}
		}


		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$data = $this->Grpshd->findAll(array('group_id in ('.$condition.')'),null, null,null,null);

		foreach ($data as $dt)
		{
			//================================= SHOW group pc==========
			$grp=$this->Grpauth->getChildrenByParent($dt['Grpshd']['group_id']);
			$condition="";
			foreach($grp as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);

			$out_group=$this->Grpshd->findAll(array('group_id!='.$dt['Grpshd']['group_id']),"distinct(group_id) AS Grpshd__group_id");
			$condition_1="";
			foreach($out_group as $key => $value){
				$condition_1.=$value['Grpshd']['group_id'].",";
			}
			$condition_1 = substr($condition_1,0,-1);
			if(!empty($condition_1))
			{
				$where_notin="group_id not in (".$condition_1.")";
				//				$where_notin="1=1";
			}
			else
			{
				$where_notin="1=1";
			}
			$cpc = $this->Rlthstgrp->findAll(array(" group_id in (".$condition.")",$where_notin,'GROUP BY'=>'host_id'),'count(Rlthstgrp.host_id) as Rlthstgrp_count', null,null,null);
			//================================= SHOW group pc==========

			/*
			$cpc = $this->Rlthstgrp->findAll(array('group_id='.$dt['Grpshd']['group_id'],'GROUP BY'=>'host_id'),'count(Rlthstgrp.host_id) as Rlthstgrp_count', null,null,null);
			//    		debug($cpc);
			*/
			$dt['count']=isset($cpc[0][0]['Rlthstgrp_count']) ? count($cpc) : null;
			$list[]=$dt;
		}
		$this->set('err',$err);
		if(!empty($list))
		{
			$this->set('data',$list);
		}
		//    	debug($list);
		$this->render('lists');
	}
	//xinw start 20080804
	function detail($id=null,$grp_id=null)
	//xinw end 20080804
	{
		$this->layout='ajax';


		//=================================1009

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			//					echo $data_lic;
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}
		//=================================1009

		//
		//    	$criteria[]=" Grpshd.id=".$id." ";
		//		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		//										'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
		//										'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//										);
		//		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_webs/contro', 'modelClass'=>'Optweb', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		//		$data = $this->Optweb->findByAsso($criteria, array('Optweb.domain', 'count(Optweb.id) as Optweb__con'), 'Optweb.domain', $limit, $page, $asso);
		//
		//		$hstlog=$this->Hstloghead->findAll(array('1=1'));
		//		$criteria=array(" Grpshd.id=".$id,'(Hstloghead.start_time != Hstloghead.prev_start_time or Hstloghead.start_time is null)','group by'=>'Grpshd.group_id,Group.group_name,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
		//		if(empty($hstlog))
		//		{
		//xinw start 20080811
		//$criteria=array(" Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Group.group_name,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
		$criteria=array("Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Group.group_name,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id,Hstloghead.last_time');
		//xinw end 20080811
		//		}
		//wangs start 20080221
		/*
		$asso = array(
		//						'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
		'Group : groups:left' => array('Group.id =Grpshd.group_id'),
		'Rltshdmod : rltshdmods:left' => array('Rltshdmod.sch_id =Grpshd.id'),
		'Rlthstgrp : rlthstgrps : LEFT' => array('Grpshd.group_id = Rlthstgrp.group_id'),
		'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
		//						'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
		//						'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id'),
		'Hstloghead : (select module_type,host_id,min(secs_between(start_time,prev_start_time)) as time_between from hstlogheads
		where secs_between(start_time,prev_start_time) !=0 group by module_type,host_id):left' => array('Hstloghead.module_type = Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
		);

		$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Group.group_name', 'Grpshd.start_date','Grpshd.end_date',
		'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft'), "Module.id", null, null, $asso);
		*/
		$asso = array(
		//						'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
		'Group : groups : LEFT' => array('Group.id = Grpshd.group_id'),
		'Rltshdmod : rltshdmods : LEFT' => array('Rltshdmod.sch_id = Grpshd.id'),
		//xinw start 20080415
		//'Rlthstgrp : rlthstgrps : LEFT' => array('Grpshd.group_id = Rlthstgrp.group_id'),
		//xinw end 20080415
		'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
		//						'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
		//						'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id'),
		
		//xinw start 20080410
//		'Hstloghead : (select module_type,host_id,max(start_time) as start_time, max(prev_start_time) as prev_start_time from hstlogheads
//  where secs_between(start_time,prev_start_time) !=0 group by module_type,host_id):left' => array('Hstloghead.module_type = Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
		//xinw start 20080714
		//xinw start 20080804
		//'Hstloghead : (select A.module_type,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),
		'Hstloghead : (select A.module_type,max(A.prev_start_time) as last_time,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' INNER JOIN (select host_id,module_type,max(start_time) as newest_time from hstlogheads group by host_id,module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time
   where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ) : LEFT' => array('Hstloghead.module_type = Module.id'),
		/*'Hstloghead : (select A.module_type,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id and B.group_id = '.$id.' INNER JOIN (select module_type,max(start_time) as newest_time from hstlogheads group by module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time
   where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),*/
		//xinw end 20080804
		//xinw end 20080714
		//xinw end 20080410
  );
  		//xinw start 20080410
//  $data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Group.group_name', 'Grpshd.start_date','Grpshd.end_date',
//  'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','secs_between(max(Hstloghead.start_time),max(Hstloghead.prev_start_time)) as Rltshdmod__timeaft'), "Module.id", null, null, $asso);
  		$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Group.group_name', 'Grpshd.start_date','Grpshd.end_date',
  		//xinw start 20080811
		'Grpshd.netscan_time',
  //'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft'), "Module.id", null, null, $asso);
  	'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft','Hstloghead.last_time as Rltshdmod__lasttime'), "Module.id", null, null, $asso);
  		//xinw end 20080811
  		//xinw end 20080410
  		
  //wangs end 20080221
  //					 debug($data);

  //		$glist = $this->Grpauth->getChildrenByParent($this->data['optweb']['group']);
  //		$condition="";
  //		foreach($glist as $key => $value){
  //		    $condition.=$key.","; 
  //		}
  //		$condition = substr($condition,0,-1);
  //		$criteria[]=" Group.id in (".$condition.") ";
  //===
  /*
  $conditions=array('Grpshd.id='.$id,'GROUP BY'=>'Host.host_name,Host.id,Group.group_name');
  $asso = array(
  //						'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
  'Rlthstgrp : rlthstgrps' => array('Grpshd.group_id = Rlthstgrp.group_id'),
  'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
  'Group : groups:left' => array('Group.id =Grpshd.group_id'),
  //						'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
  //						'Module : modules' => array('Module.id =Rltshdmod.module_id'),
  );
  //			$datapc = $this->Grpshd->findByAsso($conditions, array('count(Host.id) as Host__count','Host.host_name','Host.id'), null, null, null, $asso);
  $datapc = $this->Grpshd->findByAsso($conditions, array('Host.host_name','Host.id','Group.group_name'), null, null, null, $asso);
  */
  //===
  //wangs start 20080201
  $grpshd_data = $this->Grpshd->findById($id);
  //wangs end 20080201

  //================================= SHOW group pc==========
  $grp=$this->Grpauth->getChildrenByParent($data[0]['Grpshd']['group_id']);
  $condition="";
  foreach($grp as $key => $value){
  	$condition.=$key.",";
  }
  $condition = substr($condition,0,-1);

  $out_group=$this->Grpshd->findAll(array('group_id!='.$data[0]['Grpshd']['group_id']),"distinct(group_id) AS Grpshd__group_id");
  $condition_1="";
  foreach($out_group as $key => $value){
  	$condition_1.=$value['Grpshd']['group_id'].",";
  }
  $condition_1 = substr($condition_1,0,-1);

  if(!empty($condition_1))
  {
  	$where_notin="Group.id not in (".$condition_1.")";
  	//				$where_notin=null;
  }
  else
  {
  	$where_notin="1=1";
  }


  //			debug($out_group);
  //echo $condition_1;
  $conditions=array(" Group.id in (".$condition.")",$where_notin,'GROUP BY'=>'Host.host_name,Host.id,Group.group_name' );
  //			echo $conditions;
  $asso = array(
  //						'Rltgrpshd : rltgrpshds' => array('Rltgrpshd.sch_id =Grpshd.id'),
  'Rlthstgrp : rlthstgrps' => array('Group.id = Rlthstgrp.group_id'),
  'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
  //						'Group : groups:left' => array('Group.id =Grpshd.group_id'),
  //						'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
  );
  $datapc = $this->Group->findByAsso($conditions, array('Host.host_name','Host.id','Group.group_name'), "Group.group_name", null, null, $asso);
  //=================================group pc==========

  $pc_id=null;
  foreach ($datapc as $datapc_id)
  {
  	$pc_id.=$datapc_id['Host']['id'].",";
  }
  //			echo $pc_id;



  //			$datapc = $this->Hstdata->findByAsso(array(), array(''), null, null, null, $asso);

  //		debug($datapc);
  //		echo count($datapc);
  $this->set('count',count($datapc));

  //    	$data = $this->Grpshd->findAll('Grpshd.id='.$id,null, null,null,null);
  $this->set('datapc',$datapc);
  $this->set('data',$data);
  $this->set('id',$id);
  //    	echo $id."==".$data[0]['Grpshd']['id'];

  //wangs start 20080201
  $this->set('grpshd_data',$grpshd_data);
  //wangs end 20080201

	  //xinw start 20080701
		if (!empty($id)) {
			$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Grpshd.group_id=Rlthstgrp.group_id'),
		);
			$host_num=$this->Grpshd->findByAsso(array('Grpshd.id='.$id),array('Rlthstgrp.host_id'), null, null, null, $asso);
			$this->set('host_num',$host_num);
		}
		//xinw end 20080701


	}
	//xinw start 20080509
	//xinw start 20080804
	function add($id=null,$come=null,$id_from_grp=null,$grp_id=null)
	//xinw end 20080804
	//xinw end 20080509
	{
		$add=0;
		$err=null;
		$this->layout='ajax';
		//名前表示用
		$glist2 = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//選択用
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//**070905
		if(empty($id))
		{
			$asso = array(
			'Group : groups : LEFT' => array('Group.id = Grpshd.group_id'),
			);
			$ha_group = $this->Grpshd->findByAsso(array('1=1'),array('Group.group_name'), null,null,null,$asso);
			foreach ($glist as $key=>$g_list)
			{
				foreach ($ha_group as $ha)
				{
					if($g_list==$ha['Group']['group_name'])
					{
						unset($glist[$key]);
					}
				}
			}
		}
		//**070905
		//	  $glist[0] =  __('whole',$return = true);
		//ksort($glist);
		//=================================1016  新規スケジュール登録可能なグループがありません
		if(empty($glist))
		{
			$this->lists('group_null');
		}
		//=================================1016  新規スケジュール登録可能なグループがありません
		$this->set('glist',$glist);
		$this->set('glist2',$glist2);
		$now_group=$this->Group->findAll(array("Group.id=".$this->_getUserGroup()),"Group.group_name");
		$this->set('grpnm',$now_group[0]['Group']['group_name']);
		$data=null;
		//	  $data=array();



		//=================================1009

		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		if(!empty($license_endtime[0]['License']['end_time']))
		{
			$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
			$this->set('year_lic',$data_lic);
			//					echo $data_lic;
			$lic_endY=substr($license_endtime[0]['License']['end_time'],0,10);
			$this->set('lic_endY',substr($license_endtime[0]['License']['end_time'],0,10));
		}
		//=================================1009


		if(isset($this->data['Group']['group_name']))
		{
			if(empty($id))
			{
				$criteria[]=" Grpshd.group_id=".$this->data['Group']['group_name']." ";
				$asso = array(
				'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
				'Module : modules' => array('Module.id =Rltshdmod.module_id'),
				);
				$data_id = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Grpshd.id' ), null, null, null, null);
				if(!empty($data_id))
				{
					$id=$data_id[0]['Grpshd']['id'];
					$add=1;
				}

				//			echo "~~~~~~~~~~~~~~~~~".$id;
				//$this->GenerateFiles->hook_by_group($this->data['Group']['group_name'], array('schedule'));
			}

			if(!empty($id))
			{
				$criteria[]=" Grpshd.id=".$id." ";
				$asso = array(
				'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
				'Module : modules' => array('Module.id =Rltshdmod.module_id'),
				);
				$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id', 'Grpshd.start_date','Grpshd.end_date','Grpshd.netscan_time',
				'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id' ), 'Module.id', null, null, $asso);
				//$this->GenerateFiles->hook_by_group($id, array('schedule'));





				//===================================1012 修正
				$ck_data=$this->Somemod->findAll();
				$m_data=$this->Module->findAll();
				$lic_mo=null;
				$delmod=array();
				foreach ($ck_data as $ck)
				{
					foreach ($m_data as $da)
					{
						if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
						{
							$lic_mo.=$da['Module']['id'].",";
						}
					}
				}
				//xinw start 20080403
				$asso_auth = array(
				'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
				//'Authority:authorities'=>array('Rltuserauth.authority_id=Authority.id'),
				);
				$user = $this->Session->read('user');
				$hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
				$m_data1=$this->Module->findAll("module_name='webaccess'");
				foreach ($hava_auth as $ha)
				{
					if (in_array("opu_webs",$ha['Authority']))
					{
						$lic_mo.=$m_data1[0]['Module']['id'].",";
					}
				}

				//xinw end 20080403
				$lic_mo = substr($lic_mo,0,-1);
				$m_have_id=$this->Rltshdmod->findAll(array("1=1","Rltshdmod.sch_id=".$id),array("distinct(Rltshdmod.module_id) as Rltshdmod__module_id"));
				$condition="";
				foreach($m_have_id as $key => $value){
					$condition.=$value['Rltshdmod']['module_id'].",";
				}
				$condition = substr($condition,0,-1);

				$where[]="id in(".$lic_mo.") ";
				if(!empty($condition))
				{
					$where[]="id not in (".$condition.") ";
					$where[]="id not in (12,13,14) ";
				}
				$m_nothave=$this->Module->findAll($where);
				//    	debug($data);
				foreach ($m_nothave as $key=> $add_mod)
				{
					$data_add[]=$data[0];
					$data_add[$key]['Module']['id']=$add_mod['Module']['id'];
					$data_add[$key]['Module']['module_name']=$add_mod['Module']['module_name'];
					$data_add[$key]['Rltshdmod']['id']=null;


					if($add_mod['Module']['module_name']=='WMI')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WMI;
					}
					if($add_mod['Module']['module_name']=='webaccess')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WEB;
					}
					if($add_mod['Module']['module_name']=='device')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_DEV;
					}
					if($add_mod['Module']['module_name']=='fileinfo')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FIL;
					}
					if($add_mod['Module']['module_name']=='performance')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_PER;
					}
					if($add_mod['Module']['module_name']=='event')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_EVE;
					}
					if($add_mod['Module']['module_name']=='service')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_SER;
					}
					if($add_mod['Module']['module_name']=='antivirus')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_ANT;
					}
					if($add_mod['Module']['module_name']=='application')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_APP;
					}
					if($add_mod['Module']['module_name']=='netscan')
					{
						$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_NWSCAN;
					}

				}
				if(!empty($data_add))
				{
					$data=array_merge($data,$data_add);
				}
				//    	$ref=array_multisort($data['Module'][''],SORT_ASC);

				//    	debug($data_add);
				//debug($data);
				//===================================1012 修正

			}




			$week=null;
			$this->data['Grpshd']['mon']=='1' ? $week=$week+1 : null;
			$this->data['Grpshd']['tue']=='1' ? $week=$week+2 : null;
			$this->data['Grpshd']['wed']=='1' ? $week=$week+4 : null;
			$this->data['Grpshd']['thu']=='1' ? $week=$week+8 : null;
			$this->data['Grpshd']['fri']=='1' ? $week=$week+16 : null;
			$this->data['Grpshd']['sat']=='1' ? $week=$week+32 : null;
			$this->data['Grpshd']['sun']=='1' ? $week=$week+64 : null;

			$this->data['Grpshd']['none']=='1' ? $week=null : null;
			if(empty($week)&&$this->data['Grpshd']['none']!='1')
			{
				$err[]=__('weeks',$return = true)."　".__('E-00200',$return = true);
			}
			if(isset($this->data['Grpshd']['none']))
			{
				$this->set('wk',$this->data['Grpshd']['none']);
			}


			if(empty($this->data['Grpshd']['start_year'])&&empty($this->data['Grpshd']['start_month']))
			{
				$start_date="2038-01-01";
				//	  		 	$start_date=$lic_endY;
				$this->set('start_date',$start_date);
				//	  		 	$start_date="1980-01-01";
			}
			else
			{
				$start_date = $this->data['Grpshd']['start_year']."-".$this->data['Grpshd']['start_month']."-".$this->data['Grpshd']['start_day'];
				$this->set('start_date',$start_date);
			}

			if(empty($this->data['Grpshd']['end_year'])&&empty($this->data['Grpshd']['end_month']))
			{
				$end_date="2038-01-01";
				//	  		 	$end_date=$lic_endY;
			}
			else
			{
				$end_date = $this->data['Grpshd']['end_year']."-".$this->data['Grpshd']['end_month']."-".$this->data['Grpshd']['end_day'];
				$this->set('end_date',$end_date);
			}




			if(empty($this->data['Grpshd']['start_hour']))
			{
				$start_time="00:00:00";
				$this->set('start_time',$start_time);
			}
			else
			{
				$start_time = $this->data['Grpshd']['start_hour'].":".$this->data['Grpshd']['start_min'].":00";
				$this->set('start_time',$start_time);
			}


			if(empty($this->data['Grpshd']['end_hour']))
			{
				$end_time="23:59:59";
				$this->set('end_time',$end_time);
			}
			else
			{
				if($start_time==$this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":00")
				{
					$end_time = $this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":00";
				}
				else
				{
					$end_time = $this->data['Grpshd']['end_hour'].":".$this->data['Grpshd']['end_min'].":59";
				}
				$this->set('end_time',$end_time);
			}
			
			if(empty($this->data['Rltshdmod']['netscan_hour']))
			{
				$netscan_time="00:00:00";
				$this->set('netscan_time',$netscan_time);
			}
			else
			{
				$netscan_time = $this->data['Rltshdmod']['netscan_hour'].":".$this->data['Rltshdmod']['netscan_min'].":00";
				$this->set('netscan_time',$netscan_time);
			}
			
			//	  	     echo $id."++id";
			//debug($this->data);
			//====================DATE check=====================================
			//============================1009  licenc endtime
			$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));
			if(!empty($license_endtime) && ($end_date>$license_endtime[0]['License']['end_time'])&&$end_date!="2038-01-01")
			{
				$err[]=__('license_endtime',$return = true);
			}
			if(!empty($license_endtime[0]['License']['end_time']))
			{
				$data_lic=substr($license_endtime[0]['License']['end_time'],0,4)-date("Y");
				$this->set('year_lic',$data_lic);
				//					echo $data_lic;
			}

			//============================1009
			if($start_date>$end_date)
			{
				$err[]=__('E-01000',$return = true);
			}
			if($start_time>$end_time)
			{
				$err[]=__('E-01200',$return = true);
			}
			if(isset($this->data['Grpshd']['start_year'])&&isset($this->data['Grpshd']['end_year']))
			{
				if(false == checkdate($this->data['Grpshd']['start_month'], $this->data['Grpshd']['start_day'], $this->data['Grpshd']['start_year']) || false == checkdate($this->data['Grpshd']['end_month'], $this->data['Grpshd']['end_day'], $this->data['Grpshd']['end_year']))
				{
					$err[]=__('E-01100',$return = true);
				}
			}
			//====================DATE check=====================================
			$asso = array();
			$modid1 = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), 'Module.id', null, null, $asso);
			$errp1=0;
			//	    			echo "==============".$this->Grpshd->field('id',null,'id desc');
			if(!empty($modid1))
			{
				foreach($modid1 as $mid)
				{
					if(!empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
					{
						if(!$this->Validation->numeric($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']])&&$errp1==0)
						{
							$errp1=1;
							//xinw start 20090210
							//modify for ASP4-036
							//$err[]=__('inter_time',$return = true)."　".__('E-00500',$return = true);
							$err[]=__('inter_time_mes',$return = true)."　".__('E-04000',$return = true);
							//xinw end 20090210
						}

					}
				}

			}
			//	 				 foreach ($data as $out)
			//		    		{
			//		    			if($this->Validation->blank($this->data['Rltshdmod']['inter_time_'.$out['Rltshdmod']['id']]))
			//		    			{
			//		    				$err[]=__('inter_time',$return = true)."　".__('E-00100',$return = true);
			//		    				break;
			//		    			}
			//		    		}
			//=====================0926 修正　　　パフォーマンス・プロセス とサービス情報で9分以下を設定した場合










			//wangs start 20080131
			$dir_inter_time = null;
			//wangs end 20080131

			if(empty($id))
			{
				$asso=array();
				$modid = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), 'Module.id', null, null, $asso);
				//				debug($modid);
				foreach($modid as $mid)
				{//echo $mid['Module']['module_name']."<br>";
					$intime='';

					//wangs start 20080131
					if ($mid['Module']['module_name']=='fileinfo') {
						if(isset($this->data['Grpshd']['secend_'.$mid['Module']['id']])&&$this->data['Grpshd']['secend_'.$mid['Module']['id']]=='4')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$mid['Module']['id']]*3600*24;
						}
						elseif(isset($this->data['Grpshd']['secend_'.$mid['Module']['id']])&&$this->data['Grpshd']['secend_'.$mid['Module']['id']]=='5')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$mid['Module']['id']]*3600*24*30;
						}
					}
					//wangs end 20080131

					if($mid['Module']['module_name']!='filetransfer'&&$mid['Module']['module_name']!='error'&&$mid['Module']['module_name']!='schedule')
					//				if($mid['Module']['module_name']=='performance'||$mid['Module']['module_name']=='service'||$mid['Module']['module_name']=='device')
					{
						if(isset($this->data['Rltshdmod']['secend_'.$mid['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='2')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*60;
						}
						elseif(isset($this->data['Rltshdmod']['secend_'.$mid['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='3')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*3600;
						}
						else
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{
								$intime=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
							}
						}

						//				if($intime<60 && !empty($intime) && $mid['Module']['module_name']=='performance')
						//				{
						//					$err[]=__('err_performance',$return = true);
						//				}
						//				if($intime<180 && !empty($intime) && $mid['Module']['module_name']=='device')
						//				{
						//					$err[]=__('err_device',$return = true);
						//				}
						//
						//				if($intime<600 && !empty($intime) && $mid['Module']['module_name']=='service')
						//				{
						//					$err[]=__('err_service',$return = true);
						//				}
						if($intime<60 && !empty($intime) )
						{
							$err[]=__($mid['Module']['module_name'].'_',true).__('err_settime',$return = true);
						}


					}

				}
			}
			//=====================0926 修正　　　パフォーマンス・プロセス とサービス情報で9分以下を設定した場合










			//=====================0926 修正　　パフォーマンス・プロセス とサービス情報で9分以下を設定した場合










			if(!empty($id) )
			{
				foreach ($data as $out)
				{//debug($data);
					$intime='';
					//wangs start 20080131
					if ($out['Module']['module_name']=='fileinfo') {
						if(isset($this->data['Grpshd']['secend_'.$out['Module']['id']])&&$this->data['Grpshd']['secend_'.$out['Module']['id']]=='4')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$out['Module']['id']]*3600*24;
						}
						elseif(isset($this->data['Grpshd']['secend_'.$out['Module']['id']])&&$this->data['Grpshd']['secend_'.$out['Module']['id']]=='5')
						{
							$dir_inter_time=$this->data['Grpshd']['inter_time_'.$out['Module']['id']]*3600*24*30;
						}
					}
					//wangs end 20080131


					if($out['Module']['module_name']!='filetransfer'&&$out['Module']['module_name']!='error'&&$out['Module']['module_name']!='schedule')
					//				if($out['Module']['module_name']=='performance'||$out['Module']['module_name']=='service'||$out['Module']['module_name']=='device')
					{
						if(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='2')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*60;
						}
						elseif(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='3')
						{
							$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*3600;
						}
						else
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
							{
								$intime=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']];
							}
						}

						//				if($intime<60 && !empty($intime) && $out['Module']['module_name']=='performance')
						//				{
						//					$err[]=__('err_performance',$return = true);
						//				}
						//				if($intime<180 && !empty($intime) && $out['Module']['module_name']=='device')
						//				{
						//					$err[]=__('err_device',$return = true);
						//				}
						//
						//				if($intime<600 && !empty($intime) && $out['Module']['module_name']=='service')
						//				{
						//					$err[]=__('err_service',$return = true);
						//				}
						if($intime<60 && !empty($intime) )
						{
							$err[]=__($out['Module']['module_name'].'_',true).__('err_settime',$return = true);
						}





					}
				}
				//			if(!empty($err))
				//				{
				//					break;
				//				}
			}
			//=====================0926 修正　　　パフォーマンス・プロセス とサービス情報で9分以下を設定した場合








			if(empty($err))
			{
				//					$this->add($id);
				$sensor['id']=$id;
				$sensor['group_id']=$this->data['Group']['group_name'];
				$sensor['start_date']="'".$start_date."'";
				$sensor['end_date']="'".$end_date."'";
				$sensor['start_time']=$start_time;
				$sensor['end_time']=$end_time;
				$sensor['weekday']=$week;
				$sensor['netscan_time']=$netscan_time;

				//wangs strat 20080131
				if($this->data['Grpshd']['dev']!='grpshd_dev'){
					$this->data['Grpshd']['dev']='0';
				}else {
					$this->data['Grpshd']['dev']='1';
				}
				//zhangs start 20080313
				$this->data['Grpshd']['hdd']='1';
				//zhangs end 20080313
				//				if($this->data['Grpshd']['hdd']!='grpshd_hdd'){
				//					$this->data['Grpshd']['hdd']='0';
				//				}else {
				//					$this->data['Grpshd']['hdd']='1';
				//				}
				if($this->data['Grpshd']['dir']!='grpshd_dir'){
					$this->data['Grpshd']['dir']='0';
				}else {
					$this->data['Grpshd']['dir']='1';
				}
				$sensor['dev_file_flag']=$this->data['Grpshd']['dev'];
				$sensor['hdd_file_flag']=$this->data['Grpshd']['hdd'];
				$sensor['dir_flag']=$this->data['Grpshd']['dir'];
				$sensor['dir_inter_time']=$dir_inter_time;
				//wangs end 20080131

				$this->Grpshd->save($sensor);
				if(!empty($id))
				{
					$lastid=$id;
				}
				else
				{
					$lastid=$this->Grpshd->field('id','1=1','id desc');
				}
				////
				$pd_id=$this->Rltgrpshd->findAll(array('group_id='.$this->data['Group']['group_name']),array('sch_id'));
				if(!empty($pd_id[0]['Rltgrpshd']['sch_id'])&&empty($id))
				{
					$id=$pd_id[0]['Rltgrpshd']['sch_id'];
					$add='1';
				}
				////
				//	    		echo $pd_id[0]['Rltgrpshd']['sch_id'];


				if(!empty($id) && $add!=1)
				{
					//	    			echo "====1====";
					//	    			debug($data);
					foreach ($data as $out)
					{
						//		    			debug($this->data);

						//echo "====1====";
						if(($out['Module']['id']!= 12)&& $out['Module']['id']!= 13 && $out['Module']['id']!= 14)
						{
							if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']])&&$this->Validation->blank($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
							{
								$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]='0';
							}
							$mods['id']=$out['Rltshdmod']['id'];
							//	    			$mods['inter_time']=$out['Rltshdmod']['inter_time_'.$out['Rltshdmod']['id']];
							if(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='2')
							{
								$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*60;
							}
							elseif(isset($this->data['Rltshdmod']['secend_'.$out['Module']['id']])&&$this->data['Rltshdmod']['secend_'.$out['Module']['id']]=='3')
							{
								$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]*3600;
							}
							else
							{
								if(isset($this->data['Rltshdmod']['inter_time_'.$out['Module']['id']]))
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$out['Module']['id']];
								}
							}
							//=======================1012
							if(empty($out['Rltshdmod']['id']) && ($out['Module']['id']!= 12)&& $out['Module']['id']!= 13 && $out['Module']['id']!= 14)
							{
								$mods['sch_id']=$id;
								$mods['module_id']=$out['Module']['id'];

							}
							//=======================1012
							$this->Rltshdmod->save($mods);
							//		    			debug($mods);
							//	    			echo "====".$this->data['Rltshdmod']['inter_time_'.$out['Rltshdmod']['id']].debug($mods);;

						}
					}

				}
				elseif(empty($id))
				{	//echo "====2====";
					$asso = array(
					//					'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
					//					'Module : modules' => array('Module.id =Rltshdmod.module_id'),
					);
					//					$modid = $this->Grpshd->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Rltshdmod.module_id'), null, null, null, $asso);
					$modid = $this->Module->findByAsso(array("1=1"), array('distinct(Module.module_name) as Module__module_name','Module.id'), null, null, null, $asso);
					$errp=0;
					//	    			echo "==============".$this->Grpshd->field('id',null,'id desc');



					foreach($modid as $mid)
					{

						if(empty($err)){
							//						echo "000000000000";
							if(!empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{

								//							debug($err);

								if($this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='2')
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*60;
								}
								elseif($this->data['Rltshdmod']['secend_'.$mid['Module']['id']]=='3')
								{
									$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]*3600;
								}
								else
								{
									if(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
									{
										$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
									}
								}



								$mwhere[]="Rltshdmod.module_id=".$mid['Module']['id'];
								$mwhere[]="Rltshdmod.sch_id=".$lastid;
								$moid=$this->Rltshdmod->find($mwhere,'Rltshdmod.id');
								!empty($moid['Rltshdmod']['id'])? $mdid=$moid['Rltshdmod']['id'] :$mdid=null;
								$mods['id']=$mdid;
								//				    			$mods['inter_time']=$this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']];
								$mods['module_id']=$mid['Module']['id'];
								$mods['sch_id']=$lastid;
								$this->Rltshdmod->save($mods);


							}
							elseif(isset($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']])&&empty($this->data['Rltshdmod']['inter_time_'.$mid['Module']['id']]))
							{
								$mwhere[]="Rltshdmod.module_id=".$mid['Module']['id'];
								$mwhere[]="Rltshdmod.sch_id=".$lastid;
								$moid=$this->Rltshdmod->find($mwhere,'Rltshdmod.id');
								!empty($moid['Rltshdmod']['id'])? $mdid=$moid['Rltshdmod']['id'] :$mdid=null;
								$mods['id']=$mdid;
								$mods['inter_time']='0';
								$mods['module_id']=$mid['Module']['id'];
								$mods['sch_id']=$lastid;
								$this->Rltshdmod->save($mods);
							}
						}
					}

					//======================================================
					$glist = $this->Group->getChildrenByParent($this->data['Group']['group_name']);
					//					$condition="";
					//debug($glist);
					if(empty($err))
					{
						//		    		foreach($glist as $key => $value){
						//						   	$grpshd['group_id']=$key;
						//							$grpshd['sch_id']=$lastid;
						//							$grpshd['org_grp_id']=$lastid;
						//							$this->Rltgrpshd->save($grpshd);
						//							}
						$grpshd['group_id']=$this->data['Group']['group_name'];
						$grpshd['sch_id']=$lastid;
						$grpshd['org_grp_id']=$lastid;
						$this->Rltgrpshd->save($grpshd);
					}
					//					$condition = substr($condition,0,-1);
					//					$grpshd['group_id']=$this->data['Group']['group_name'];
					//					$grpshd['sch_id']=$lastid;
					//					$grpshd['org_grp_id']=$lastid;
					//======================================================


				}
				$this->GenerateFiles->hook_by_group($this->data['Group']['group_name'], array('schedule'));
			}
			//	    		echo "===========================================".$this->data['Group']['group_name'];

			//	    		echo "===".$this->data['Group']['group_name'];
		}



		$criteria[]="1=1";
		if(!empty($id))
		{
			//echo "===";
			//	  	$hstlog=$this->Hstloghead->findAll(array('1=1'));
			//	  	if(empty($hstlog))
			//	  	{
			//xinw start 20080811
			//$criteria=array(" Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
			$criteria=array(" Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.id,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id,Hstloghead.last_time');
			//xinw end 20080811
			//	  	}
			//	  	else
			//	  	{
			//	  		$criteria=array(" Grpshd.id=".$id,'(Hstloghead.start_time != Hstloghead.prev_start_time or Hstloghead.start_time is null)','group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
			//	  	}
			//	 	$criteria=array(" Grpshd.id=".$id,'Hstloghead.start_time != Hstloghead.prev_start_time','group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
			//*
			//wangs start 20080221
			/*
			$asso = array(
			//					'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			'Rltshdmod : rltshdmods:left' => array('Rltshdmod.sch_id =Grpshd.id'),
			'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
			'Rlthstgrp : rlthstgrps : LEFT' => array('Grpshd.group_id = Rlthstgrp.group_id'),
			//					'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
			//					'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id'),
			'Hstloghead : (select module_type,host_id,min(secs_between(start_time,prev_start_time)) as time_between from hstlogheads
			where secs_between(start_time,prev_start_time) !=0 group by module_type,host_id):left' => array('Hstloghead.module_type = Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
			);

			$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id', 'Grpshd.start_date','Grpshd.end_date',
			'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft' ), null, null, null, $asso);
			*/
			//xinw start 20080804
			//xinw start 20090210
			//modify for ASP4-036
			//empty($grp_id)?$grp_id=$id_from_grp:null;
			empty($grp_id)?$grp_id=$id:null;
			$this->set('grp_id',$grp_id);
			//xinw end 20090210
			//xinw end 20080804
			$asso = array(
			//					'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			'Rltshdmod : rltshdmods:left' => array('Rltshdmod.sch_id =Grpshd.id'),
			'Module : modules:left' => array('Module.id =Rltshdmod.module_id'),
			//xinw start 20080415
			//'Rlthstgrp : rlthstgrps : LEFT' => array('Grpshd.group_id = Rlthstgrp.group_id'),
			//xinw end 20080415
			//					'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
			//					'Hstloghead : hstlogheads:left' => array('Hstloghead.module_type =Module.id'),
			//xinw start 20080410
//			'Hstloghead : (select module_type,host_id,max(start_time) as start_time, max(prev_start_time) as prev_start_time from hstlogheads
// where secs_between(start_time,prev_start_time) !=0 group by module_type,host_id):left' => array('Hstloghead.module_type = Module.id','Hstloghead.host_id=Rlthstgrp.host_id'),
// );
//
// $data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id', 'Grpshd.start_date','Grpshd.end_date',
// 'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','secs_between(max(Hstloghead.start_time),max(Hstloghead.prev_start_time)) as Rltshdmod__timeaft' ), null, null, null, $asso);
			//xinw start 20080714
			//xinw start 20080804
			//'Hstloghead : (select A.module_type,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),
			  'Hstloghead : (select A.module_type,max(A.prev_start_time) as last_time,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id INNER JOIN groups AS D on D.id=B.group_id and D.id='.$grp_id.' INNER JOIN (select host_id,module_type,max(start_time) as newest_time from hstlogheads group by host_id,module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),
			/*'Hstloghead : (select A.module_type,min(secs_between(A.start_time,A.prev_start_time)) as time_between from hstlogheads AS A LEFT JOIN rlthstgrps AS B ON A.host_id=B.host_id and B.group_id = '.$id.' INNER JOIN (select module_type,max(start_time) as newest_time from hstlogheads group by module_type ) AS C ON A.module_type = C.module_type and A.start_time = C.newest_time
   where secs_between(A.start_time,A.prev_start_time) !=0 group by A.module_type ):left' => array('Hstloghead.module_type = Module.id'),*/
			//xinw end 20080804
			//xinw end 20080714
			);
			$data = $this->Grpshd->findByAsso($criteria, array('Grpshd.group_id','Grpshd.start_date','Grpshd.end_date',
			'Grpshd.netscan_time',
			//xinw start 20080811
  			//'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft'),null, null, null, $asso);
			'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.id','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','min(Hstloghead.time_between) as Rltshdmod__timeaft','Hstloghead.last_time as Rltshdmod__lasttime'),null, null, null, $asso);
  			//xinw start 20080811
  			//xinw end 20080410
 //wangs end 20080221
 //					 'Grpshd.start_time','Grpshd.end_time','Grpshd.weekday','Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','sum(secs_between(Hstloghead.start_time, Hstloghead.end_time)) as Rltshdmod__timelog','count(secs_between(Hstloghead.start_time, Hstloghead.end_time)) as Rltshdmod__timecount','min(secs_between(Hstloghead.start_time , Hstloghead.prev_start_time)) as Rltshdmod__timeaft' ), null, null, null, $asso);
 //		debug($data);
 //*/

 //wangs start 20080201
 $grpshd_data = $this->Grpshd->findById($id);
 //wangs end 20080201

 //===================================1012 修正
 $ck_data=$this->Somemod->findAll();
 $m_data=$this->Module->findAll();
 $lic_mo=null;
 $delmod=array();
 foreach ($ck_data as $ck)
 {
 	foreach ($m_data as $da)
 	{
 		if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
 		{
 			$lic_mo.=$da['Module']['id'].",";
 		}
 	}
 }
 //xinw start 20080403
 $asso_auth = array(
 'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
 //'Authority:authorities'=>array('Rltuserauth.authority_id=Authority.id'),
 );
 $user = $this->Session->read('user');
 $hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
 $m_data1=$this->Module->findAll("module_name='webaccess'");
 foreach ($hava_auth as $ha)
 {
 	if (in_array("opu_webs",$ha['Authority']))
 	{
 		$lic_mo.=$m_data1[0]['Module']['id'].",";
 	}
 }

 //xinw end 20080403
 $lic_mo = substr($lic_mo,0,-1);
 $m_have_id=$this->Rltshdmod->findAll(array("1=1","Rltshdmod.sch_id=".$id),array("distinct(Rltshdmod.module_id) as Rltshdmod__module_id"));
 $condition="";
 foreach($m_have_id as $key => $value){
 	$condition.=$value['Rltshdmod']['module_id'].",";
 }
 $condition = substr($condition,0,-1);

 $where[]="id in(".$lic_mo.") ";
 if(!empty($condition))
 {
 	$where[]="id not in (".$condition.") ";
 	$where[]="id not in (12,13,14) ";
 }
 $m_nothave=$this->Module->findAll($where);
 //    	debug($m_nothave);
 foreach ($m_nothave as $key=> $add_mod)
 {
 	$data_add[]=$data[0];
 	$data_add[$key]['Module']['id']=$add_mod['Module']['id'];
 	$data_add[$key]['Module']['module_name']=$add_mod['Module']['module_name'];
 	$data_add[$key]['Rltshdmod']['id']=null;
 	//    	echo $add_mod['Module']['module_name'];
 	//    	debug($data_add);
 	if($add_mod['Module']['module_name']=='WMI')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WMI;
 	}
 	if($add_mod['Module']['module_name']=='webaccess')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_WEB;
 	}
 	if($add_mod['Module']['module_name']=='device')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_DEV;
 	}
 	if($add_mod['Module']['module_name']=='fileinfo')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_FIL;
 	}
 	if($add_mod['Module']['module_name']=='performance')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_PER;
 	}
 	if($add_mod['Module']['module_name']=='event')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_EVE;
 	}
 	if($add_mod['Module']['module_name']=='service')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_SER;
 	}
 	if($add_mod['Module']['module_name']=='antivirus')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_ANT;
 	}
 	if($add_mod['Module']['module_name']=='application')
 	{
 		$data_add[$key]['Rltshdmod']['inter_time']=SCHEDULE_APP;
 	}


 }
 if(!empty($data_add))
 {
 	$data=array_merge($data,$data_add);
 }
 //    	debug($data_add);
 //debug($data);
 //===================================1012 修正

 if(isset($this->data['Group']['group_name'])&&empty($err))
 {
 	$this->lists();
 }
		}
		else
		{

			$asso = array(
			//					'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			//					'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
			//					'Module : modules' => array('Module.id =Rltshdmod.module_id'),
			);
			//		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_webs/contro', 'modelClass'=>'Optweb', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
			$data = $this->Module->findByAsso(array('1=1'), array('distinct(Module.module_name) as Module__module_name','Module.id'), "Module.id", null, null, $asso);

			//		$this->Config->read('SCHEDULE_APP');
			foreach ($data as $key=>$dt)
			{
				if($dt['Module']['module_name']=='WMI')
				{
					$data[$key]['Module']['sche']=SCHEDULE_WMI;
				}
				if($dt['Module']['module_name']=='webaccess')
				{
					$data[$key]['Module']['sche']=SCHEDULE_WEB;
				}
				if($dt['Module']['module_name']=='device')
				{
					$data[$key]['Module']['sche']=SCHEDULE_DEV;
				}
				if($dt['Module']['module_name']=='fileinfo')
				{
					$data[$key]['Module']['sche']=SCHEDULE_FIL;
				}
				if($dt['Module']['module_name']=='performance')
				{
					$data[$key]['Module']['sche']=SCHEDULE_PER;
				}
				if($dt['Module']['module_name']=='event')
				{
					$data[$key]['Module']['sche']=SCHEDULE_EVE;
				}
				if($dt['Module']['module_name']=='service')
				{
					$data[$key]['Module']['sche']=SCHEDULE_SER;
				}
				if($dt['Module']['module_name']=='antivirus')
				{
					$data[$key]['Module']['sche']=SCHEDULE_ANT;
				}
				if($dt['Module']['module_name']=='application')
				{
					$data[$key]['Module']['sche']=SCHEDULE_APP;
				}
				if($dt['Module']['module_name']=='netscan')
				{
					$data[$key]['Module']['sche']=SCHEDULE_NWSCAN;
				}
			}
			//===========
			//			$this->lists();
			if(isset($this->data['Group']['group_name'])&&empty($err))
			{
				$this->lists();
			}
			//================
			//			echo "=======================+++======================";
			//		debug($data);

		}
		$ckdata=$this->Somemod->findAll();
		//	  echo $id."==".$data[0]['Grpshd']['id'];
		$this->set('ckdata',$ckdata);
		$this->set('data',$data);
		$this->set('id',$id);
		$this->set('err',$err);

		//wangs start 20080201
		$this->set('grpshd_data',$grpshd_data);
		//wangs end 20080201

		!empty($come)?$this->set('come',$come):null;

		//xinw start 20080321
		$file_sign = $this->Somemod->findAll();
		$this->set('file_sign',$file_sign);
		//xinw end 20080321
		

		//xinw start 20080402
		$asso_auth = array(
		'Rltuserauth : rltuserauths' => array('Authority.id=Rltuserauth.authority_id'),
		//'Authority:authorities'=>array('Rltuserauth.authority_id=Authority.id'),
		);
		$user = $this->Session->read('user');
		$hava_auth=$this->Authority->findByAsso(array('user_id='.$user['id']),array('Authority.controller_name'), null, null, null, $asso_auth);
		$opu_webs="";
		$oper="";
		for ($i=0;$i<count($hava_auth);$i++)
		{
			if ($hava_auth[$i]['Authority']['controller_name']=='opu_webs') {
				$opu_webs="yes";
				$k=count($ckdata);
				$code=md5("webaccesstail");
				if (!in_array($code,$ckdata)) {
					$ckdata[$k]['Somemod']['authoritied']=$code;
				}
			}
		}
//		for ($i=0;$i<count($hava_auth);$i++)
//		{
//			if ($hava_auth[$i]['Authority']['controller_name']=='oper') {
//				$oper="yes";
//				//echo "2222222222222222222222";
//			}
//		}
		$this->set('ckdata',$ckdata);
		//xinw end 20080402
		
		//xinw start 20080508
		if (!empty($id_from_grp) && $id_from_grp!="null" ) {
			$this->data['Group']['group_name']=$id_from_grp;
			$this->set('id_from_grp',$id_from_grp);
		}
		
		
		if(!empty($id_from_grp) && $id_from_grp!="null" )
		{

			foreach ($glist as $key=>$g_list)
			{
						if ($key!=$id_from_grp) {
							unset($glist[$key]);
						}		
			}
		}
		//ksort($glist);
		$this->set('glist',$glist);
		//xinw end 20080508
		 //xinw start 20080701
		if (!empty($id)) {
			$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Grpshd.group_id=Rlthstgrp.group_id'),
		);
			$host_num=$this->Grpshd->findByAsso(array('Grpshd.id='.$id),array('Rlthstgrp.host_id'), null, null, null, $asso);
			$this->set('host_num',$host_num);
		}
		//xinw end 20080701

	}

	function lic()
	{
		$ckdata=$this->Somemod->findAll();
		$data=$this->Module->findAll();
		$lic_mo=null;
		$delmod=array();
		foreach ($ckdata as $ck)
		{
			foreach ($data as $da)
			{
				if(md5($da['Module']['module_name']."tail")==$ck['Somemod']['authoritied'])
				{
					$lic_mo.=$da['Module']['id'].",";
				}
			}
		}
		$lic_mo = substr($lic_mo,0,-1);
		if(!empty($lic_mo))
		{
			$delmod[]="module_id not in(".$lic_mo.") ";
			$delmod[]="module_id not in(12,13,14) ";

		}
		else
		{
			$delmod[]="1=1";
			$delmod[]="module_id not in(12,13,14) ";
		}
		$this->Rltshdmod->deleteAll($delmod);



		//===========date
		$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));

		$set_endtime=$this->Grpshd->findAll(array("1=1"),array("Grpshd.id","Grpshd.start_date","Grpshd.end_date"));
		if(!empty($set_endtime))
		{
			foreach ($set_endtime as $endtime)
			{
				//    		foreach ($license_endtime as $lic_end)
				//    		{
				$lic_date=array();
				if(($endtime['Grpshd']['end_date']>$license_endtime[0]['License']['end_time'])&&($endtime['Grpshd']['end_date']!='2038-01-01') )
				{
					//	    				if($endtime['Grpshd']['start_date']==$endtime['Grpshd']['end_date']) //無期限
					//	    				{
					//	    					$lic_date['start_date']="'".$license_endtime[0]['License']['end_time']."'";
					//	    					$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
					//	    				}
					if(($endtime['Grpshd']['start_date']>$license_endtime[0]['License']['end_time']))  //無期限
					{
						$lic_date['start_date']="'".$license_endtime[0]['License']['end_time']."'";
						$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
					}
					else
					{
						$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
					}
					$lic_date['id']=$endtime['Grpshd']['id'];
					$this->Grpshd->save($lic_date);

				}
				//    			elseif(($endtime['Grpshd']['start_date']==$endtime['Grpshd']['end_date']))    //無期限
				//    			{
				//
				//    					$lic_date['start_date']="'".$license_endtime[0]['License']['end_time']."'";
				//    					$lic_date['end_date']="'".$license_endtime[0]['License']['end_time']."'";
				//    					$lic_date['id']=$endtime['Grpshd']['id'];
				//		    			$this->Grpshd->save($lic_date);
				//    			}
				//    		}
			}
		}
		//===========date
		$this->GenerateFiles->hook_by_ps(0, array('schedule'));
		//    	echo $lic_mo;
		//    	$this->set('ckdata',$ckdata);
		//	    $this->set('data',$data);
	}


	//    function schedule()
	//    {
	//    	$this->GenerateFiles->setFileName("SCHEDULE");
	//    	$version = 100;
	//    	$schedule = $this->Grpshd->findAll(null, null, null, null, null, 0);
	////    	$schedules = $this->Grpshd->findByAsso(array("1=1"),
	////												array('Grpshd.id', 'Mail.id'), 'Grpshd.id', null, null,
	////												array("Rltshdmod : rltshdmods" => array('Rltshdmod.sch_id =Grpshd.id'))
	////												);
	//
	//
	//
	//
	//    	$rec = $this->GenerateFiles->enc_dword($version);
	//    	$rec .=$this->GenerateFiles->enc_dword(time());
	//    	$rec .=$this->GenerateFiles->enc_dword(count($schedule));
	//    	foreach ($schedule as $scd)
	//    	{
	////    		debug($scd['Grpshd']['start_date']." ".$scd['Grpshd']['start_time']);
	//    		$rec .=$this->GenerateFiles->enc_dword($scd['Grpshd']['id']);
	//    		$rec .=$this->GenerateFiles->enc_dword($scd['Grpshd']['group_id']);
	//    		$rec .=$this->GenerateFiles->enc_dword(strtotime($scd['Grpshd']['start_date']." ".$scd['Grpshd']['start_time']));
	//    		$rec .=$this->GenerateFiles->enc_dword(strtotime($scd['Grpshd']['end_date']." ".$scd['Grpshd']['end_time']));
	//    		$rec .=$this->GenerateFiles->enc_dword($scd['Grpshd']['weekday']);
	//
	//
	//    		$modules = $this->Module->findAll(null, null, null, null, null, 0);
	//
	//    		foreach ($modules as $key=>$modl)
	//    		{
	//    			if($key>7)
	//    			{continue;}
	//    				$inter = $this->Rltshdmod->findAll(array('Rltshdmod.module_id='.$modl['Module']['id'],'Rltshdmod.sch_id='.$scd['Grpshd']['id']), null, null, null, null, 0);
	////    	debug($inter);
	//    			empty($inter)? $inte=null:$inte=$inter[0]['Rltshdmod']['inter_time'];
	//    			$rec .=$this->GenerateFiles->enc_dword($inte);
	//    			$rec .=$this->GenerateFiles->enc_dword(1);
	//    		}
	//
	//
	////    				$criteria=array(" Grpshd.id=".$id,'group by'=>'Grpshd.group_id,Grpshd.start_date,Grpshd.end_date,Grpshd.start_time,Grpshd.end_time,Grpshd.weekday,Module.module_name,Rltshdmod.inter_time,Rltshdmod.id');
	////		$asso = array(
	////					'Rltshdmod : rltshdmods' => array('Rltshdmod.sch_id =Grpshd.id'),
	//////					'Module : modules' => array('Module.id =Rltshdmod.module_id'),
	//////					'Hstloghead : hstlogheads:left' => array('Hstloghead.file_type =Module.id'),
	////					);
	////
	////		$schedules = $this->Grpshd->findByAsso($criteria, array('Module.module_name','Rltshdmod.inter_time','Rltshdmod.id','sum(secs_between(Hstloghead.start_time, Hstloghead.end_time)) as Rltshdmod__timelog','count(secs_between(Hstloghead.start_time, Hstloghead.end_time)) as Rltshdmod__timecount' ), null, null, null, $asso);
	//
	//    	}
	//    	$this->GenerateFiles->write_files($rec);
	//    }
}
?>