insert into modules values (17, 'netscan') ;
insert into authorities values (90, 'lbg[NXL', 'assets_netscan');

create table netscan (
	id int auto_increment, primary key(id),
	group_id INTEGER default null,
	ps_id INTEGER default null,
	ip_address VARCHAR(50) default null,
	mac_address VARCHAR(50) default null,
	ip_subnet VARCHAR(50) default null,
	broadcast VARCHAR(50) default null,
	pc_name VARCHAR(50) default null,
	model_name VARCHAR(256) default null,
	print_count INTEGER default null,
	init_date DATETIME default 0,
	final_date DATETIME default 0
);

create table mac2vendor(
	mac VARCHAR(50) default null,
	vendor VARCHAR(100) default null
);

create index mac_mac2vendor on mac2vendor ( mac );

alter table grpshds add column(
  netscan_time time default null
 );
 
insert into authorities values (91, 'lbg[NXLݒ', 'system_all_netscanconf');

create table netscanconfs (
 id int auto_increment, primary key(id),
 group_id  INTEGER default null ,
 ps_id  INTEGER default null ,
 span_time  INTEGER default null ,
 start_date  DATE default null ,
 start_time  TIME default null ,
 end_date  DATE default null ,
 end_time  TIME default null ,
 weekday  SMALLINT default null,
 ip_from varchar(20) not null,
 ip_to varchar(20) not null );



alter table hosts add column(
  ostype integer default 1
 );